VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsStripMapButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

' Copyright 2006 ESRI
'
' All rights reserved under the copyright laws of the United States
' and applicable international laws, treaties, and conventions.
'
' You may freely redistribute and use this sample code, with or
' without modification, provided you include the original copyright
' notice and use restrictions.
'
' See use restrictions at /arcgis/developerkit/userestrictions.

Option Explicit

Implements ICommand

Private m_pApp As IApplication

Private Sub Class_Terminate()
20:     Set m_pApp = Nothing
End Sub

Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
24:     ICommand_Bitmap = frmResources.picCreateStripMap.Picture.handle
End Property

Private Property Get ICommand_Caption() As String
28:     ICommand_Caption = "Strip Map"
End Property

Private Property Get ICommand_Category() As String
32:     ICommand_Category = "USACE JAMB"
End Property

Private Property Get ICommand_Checked() As Boolean

End Property

Private Property Get ICommand_Enabled() As Boolean
40:     ICommand_Enabled = True
End Property

Private Property Get ICommand_HelpContextID() As Long

End Property

Private Property Get ICommand_HelpFile() As String

End Property

Private Property Get ICommand_Message() As String
52:     ICommand_Message = "Create Strip Map Grid polygon features in ArcMap"
End Property

Private Property Get ICommand_Name() As String
56:     ICommand_Name = "JAMB_Front_End.clsStripMapButton"
End Property

Private Sub ICommand_OnClick()
    On Error GoTo eh
61:     Set frmSMapSettings.m_Application = m_pApp
62:     frmSMapSettings.Tickle
63:     SetWindowLong frmSMapSettings.hwnd, GWL_HWNDPARENT, m_pApp.hwnd
64:     frmSMapSettings.Show vbModeless
    Exit Sub
eh:
67:     If Err.Number <> 364 Then
68:         MsgBox "Error in clsStripMapButton_OnClick.  Error " & Err.Number & ": " & Erl & " - " & Err.Description
69:     End If
End Sub

Private Sub ICommand_OnCreate(ByVal hook As Object)
73:     Set m_pApp = hook
End Sub

Private Property Get ICommand_Tooltip() As String
77:     ICommand_Tooltip = "Create StripMap Grids"
End Property
