VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmExport 
   Caption         =   "Export"
   ClientHeight    =   4020
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5595
   LinkTopic       =   "Form1"
   ScaleHeight     =   4020
   ScaleWidth      =   5595
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtFilename 
      Height          =   315
      Left            =   840
      TabIndex        =   12
      Top             =   30
      Width           =   3375
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "Browse..."
      Height          =   375
      Left            =   4440
      TabIndex        =   11
      Top             =   0
      Width           =   855
   End
   Begin VB.ComboBox cboSaveAsType 
      Height          =   315
      Left            =   1200
      TabIndex        =   10
      Top             =   870
      Width           =   3015
   End
   Begin VB.CommandButton cmdOptions 
      Caption         =   "Options..."
      Height          =   375
      Left            =   4440
      TabIndex        =   9
      Top             =   840
      Width           =   855
   End
   Begin VB.CommandButton cmdExport 
      Caption         =   "&OK"
      Height          =   375
      Left            =   3870
      TabIndex        =   8
      Top             =   3300
      Width           =   735
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   4770
      TabIndex        =   7
      Top             =   3300
      Width           =   735
   End
   Begin VB.Frame fraPageRange 
      Caption         =   "Page range"
      Height          =   2295
      Left            =   90
      TabIndex        =   0
      Top             =   1380
      Width           =   3615
      Begin VB.OptionButton optAll 
         Caption         =   "All"
         Height          =   255
         Left            =   240
         TabIndex        =   5
         Top             =   360
         Value           =   -1  'True
         Width           =   615
      End
      Begin VB.OptionButton optCurrentPage 
         Caption         =   "Current page"
         Height          =   255
         Left            =   240
         TabIndex        =   4
         Top             =   720
         Width           =   1215
      End
      Begin VB.OptionButton optPages 
         Caption         =   "Pages:"
         Height          =   255
         Left            =   240
         TabIndex        =   3
         Top             =   1080
         Width           =   855
      End
      Begin VB.TextBox txtPages 
         Height          =   375
         Left            =   1200
         TabIndex        =   2
         Top             =   1020
         Width           =   1575
      End
      Begin VB.CheckBox chkDisabled 
         Caption         =   "Don't output disabled pages"
         Height          =   255
         Left            =   240
         TabIndex        =   1
         Top             =   1920
         Width           =   2295
      End
      Begin VB.Label lblDescription 
         Caption         =   "Enter page number and/ or page ranges separated by commas.  For example, 1,2,5-12"
         Height          =   375
         Left            =   240
         TabIndex        =   6
         Top             =   1440
         Width           =   3255
      End
   End
   Begin MSComDlg.CommonDialog dlgExport 
      Left            =   4800
      Top             =   1380
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DialogTitle     =   "Export"
   End
   Begin VB.Label Label1 
      Caption         =   "The name of the page will be appended to the specified file name."
      Height          =   225
      Left            =   300
      TabIndex        =   16
      Top             =   420
      Width           =   4755
   End
   Begin VB.Label lblStatus 
      Height          =   225
      Left            =   75
      TabIndex        =   15
      Top             =   3735
      Width           =   5445
   End
   Begin VB.Label lblExportTo 
      Caption         =   "Export to:"
      Height          =   255
      Left            =   60
      TabIndex        =   14
      Top             =   60
      Width           =   735
   End
   Begin VB.Label lblExportType 
      Caption         =   "Save as Type:"
      Height          =   255
      Left            =   60
      TabIndex        =   13
      Top             =   900
      Width           =   1095
   End
End
Attribute VB_Name = "frmExport"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

' Copyright 2006 ESRI
'
' All rights reserved under the copyright laws of the United States
' and applicable international laws, treaties, and conventions.
'
' You may freely redistribute and use this sample code, with or
' without modification, provided you include the original copyright
' notice and use restrictions.
'
' See use restrictions at /arcgis/developerkit/userestrictions.

Private m_pProgress As IModelessFrame

Private m_pMapPage As IDSMapPage
Private m_pMapSeries As IDSMapSeries
Private m_pMapBook As IDSMapBook
Private m_pApp As IApplication
Private m_pExport As IExport
Private m_pExportFrame As IModelessFrame

Private m_ExportersCol As New Collection
Private m_sFileExtension As String
Private m_sFileNameRoot As String
Private m_sPath As String

Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" _
    (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, _
    lpData As Any, lpcbData As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, _
    ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, _
    ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal _
    cbData As Long) As Long

Private Const HKEY_CURRENT_USER = &H80000001
Private Const REG_SZ = 1
Private Const REG_BINARY = 3
Private Const REG_DWORD = 4
Private Const REG_MULTI_SZ = 7
Private Const SYNCHRONIZE = &H100000
Private Const READ_CONTROL = &H20000
Private Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Private Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_READ = ((READ_CONTROL Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Private Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
Private Const ERROR_SUCCESS = 0&


Public Property Get aDSMapPage() As IDSMapPage
57:     Set aDSMapPage = m_pMapPage
End Property

Public Property Let aDSMapPage(ByVal pMapPage As IDSMapPage)
61:     Set m_pMapPage = pMapPage
End Property

Public Property Let ExportFrame(ByVal pExportFrame As IModelessFrame)
65:     Set m_pExportFrame = pExportFrame
End Property

Public Property Get aDSMapSeries() As IDSMapSeries
69:     Set aDSMapSeries = m_pMapSeries
End Property

Public Property Let aDSMapSeries(ByVal pMapSeries As IDSMapSeries)
73:     Set m_pMapSeries = pMapSeries
End Property

Public Property Get aDSMapBook() As IDSMapBook
77:     Set aDSMapBook = m_pMapBook
End Property

Public Property Let aDSMapBook(ByVal pMapBook As IDSMapBook)
81:     Set m_pMapBook = pMapBook
End Property

Public Property Get Application() As IApplication
85:     Set Application = m_pApp
End Property

Public Property Let Application(ByVal pApp As IApplication)
89:     Set m_pApp = pApp
End Property

Public Sub SetupDialog()
  On Error GoTo ErrorHandler
  
  Exit Sub
ErrorHandler:
97:   MsgBox "SetupDialog - " & Erl & " - " & Err.Description
End Sub

Private Sub cmdBrowse_Click()
  Dim sFileName As String
  Dim pTempExport As IExport
  Dim sFileFilter As String
  Dim i As Integer
  
106:   For i = 1 To m_ExportersCol.count
107:     Set pTempExport = m_ExportersCol.Item(i)
108:     Debug.Print pTempExport.Name & ": " & pTempExport.Priority
109:     If pTempExport.Filter <> "" Then
110:       If sFileFilter <> "" Then sFileFilter = sFileFilter & "|"
111:       sFileFilter = sFileFilter & pTempExport.Filter
112:     End If
113:   Next
114:   Set pTempExport = Nothing
  
116:   Me.dlgExport.Filter = sFileFilter
    
118:   If Me.cboSaveAsType.ListIndex <> -1 Then
119:     Me.dlgExport.FilterIndex = Me.cboSaveAsType.ListIndex + 1
120:   Else
121:     Me.dlgExport.FilterIndex = 1
122:   End If
  
124:   Me.dlgExport.DialogTitle = "Export"
125:   Me.dlgExport.FileName = m_sFileNameRoot & m_sFileExtension
  
' Me.Hide
128:   m_pExportFrame.Visible = False

  
131:   Me.dlgExport.ShowSave
  
133:   If Me.dlgExport.FileName = "" Then
134:       Me.Show
      Exit Sub
136:   Else
137:       sFileName = Me.dlgExport.FileName
138:   End If
  
140:   Me.txtFilename.Text = sFileName
  
142:   m_pExportFrame.Visible = True
  
End Sub

Private Sub cmdCancel_Click()
147:     m_pExportFrame.Visible = False
148:     Unload Me
End Sub

Public Sub InitializeTheForm()
On Error GoTo ErrorHandler
  Dim pTempExport As IExport
  Dim i As Integer
  Dim esriExportsCat As New UID
  Dim pCategoryFactory As ICategoryFactory
  Dim TempExportersCol As New Collection
  Dim pSettingsInRegistry As ISettingsInRegistry
  Dim iHighest As Double
  Dim sLastUsedExporterName As String
  Dim lLastUsedExporterPriority As Long
  
  
  
  'Use a Category Factory object to create one instance of every class registered
  ' in the "ESRI Exports" category.
   'Component Category: "ESRI Exports" = {66A7ECF7-9BE1-4E77-A8C7-42D3C62A2590}
168:   esriExportsCat.value = "{66A7ECF7-9BE1-4E77-A8C7-42D3C62A2590}"
169:   Set pCategoryFactory = New CategoryFactory
170:   pCategoryFactory.CategoryID = esriExportsCat
  
  'As each exporter object is created, add it to a vb collection object for later use.
  ' Use each exporter object's Priority property as a unique static key for later
  ' access to each object in the collection.  Because some exporters change their file
  ' extension based on settings (eg. SVG), we should read and sync the registry values
  ' for each exporter after it is created.
177:   Set pTempExport = pCategoryFactory.CreateNext
178:   Do While Not pTempExport Is Nothing
    On Error Resume Next
180:     Set pSettingsInRegistry = pTempExport
    On Error GoTo 0
182:     If Not pSettingsInRegistry Is Nothing Then
183:       pSettingsInRegistry.RestoreForCurrentUser "Software\ESRI\Export\ExportObjectsParams"
184:       m_ExportersCol.Add pTempExport, CStr(pTempExport.Priority)
185:     End If
186:     Set pTempExport = pCategoryFactory.CreateNext
187:   Loop
188:   Set pTempExport = Nothing

  'Run a simple sort operation on the exporters collection, sorting by the exporter
  ' Priority property.  This property is primarily used only for determining the order in
  ' which the exporters are listed in the dialog listbox control.
193:   iHighest = -4294967296#
  Dim j As Integer
195:   Do While m_ExportersCol.count > 0
196:     For i = 1 To m_ExportersCol.count
197:       Set pTempExport = m_ExportersCol(i)
198:       If pTempExport.Priority > iHighest Then
199:         iHighest = pTempExport.Priority
200:       End If
201:     Next
202:     Set pTempExport = m_ExportersCol(CStr(iHighest))
203:     TempExportersCol.Add pTempExport, CStr(pTempExport.Priority)
204:     m_ExportersCol.Remove CStr(iHighest)
205:     iHighest = -4294967296#
206:   Loop
207:   Set m_ExportersCol = TempExportersCol
208:   Set TempExportersCol = Nothing
  
  'Populate the SaveAsType combo box.  VB combo box controls provide the ItemData property, in
  ' which the user to store a data value of type long.  Each value will be associated with each
  ' string entry in the list.  Assign the value of the Priority property to ItemData, so we
  ' can grab it at a later point to tie an exporter object to the selected string entry.
214:   For i = 1 To m_ExportersCol.count
215:     Set pTempExport = m_ExportersCol.Item(i)
216:     Debug.Print pTempExport.Name & ": " & pTempExport.Priority
217:     If pTempExport.Filter <> "" Then
218:       Me.cboSaveAsType.AddItem Split(pTempExport.Filter, "|")(0)
219:       cboSaveAsType.ItemData(cboSaveAsType.NewIndex) = pTempExport.Priority
220:     End If
221:   Next
  
  
  ' get the last used export type from the registry.
225:   If GetRegistryValue(HKEY_CURRENT_USER, "Software\ESRI\Export\ExportDlg", "LastExporter", REG_SZ) <> "" Then _
    sLastUsedExporterName = GetRegistryValue(HKEY_CURRENT_USER, "Software\ESRI\Export\ExportDlg", "LastExporter", REG_SZ)
  
228:   For i = 1 To m_ExportersCol.count
229:     Set pTempExport = m_ExportersCol.Item(i)
230:     If pTempExport.Name = sLastUsedExporterName Then
231:       Debug.Print pTempExport.Name & ": " & pTempExport.Priority
232:       lLastUsedExporterPriority = pTempExport.Priority
233:     End If
234:   Next
  
236:   For i = 0 To Me.cboSaveAsType.ListCount - 1
237:     If Me.cboSaveAsType.ItemData(i) = lLastUsedExporterPriority Then
238:         Me.cboSaveAsType.ListIndex = i
239:     End If
240:   Next
  
242:   If Me.cboSaveAsType.ListIndex = -1 Then
243:     Me.cboSaveAsType.ListIndex = 0
244:   End If
  
246:   Set pTempExport = Nothing

  'assign the last used export path to m_sPath.  Get the value from the registry.
249:   If GetRegistryValue(HKEY_CURRENT_USER, "Software\ESRI\Export\ExportDlg", "WorkingDirectory", REG_SZ) <> "" Then _
    m_sPath = GetRegistryValue(HKEY_CURRENT_USER, "Software\ESRI\Export\ExportDlg", "WorkingDirectory", REG_SZ)
251:   If Right(m_sPath, 1) <> "\" Then _
    m_sPath = m_sPath & "\"
    

255:   m_sFileNameRoot = Left(GetMxdName(), Len(GetMxdName()) - 4)
  
  ' Call the InitExporter procedure to QI the m_pExport onto the currently selected exporter class
258:   InitExporter
  Exit Sub
ErrorHandler:
261:   MsgBox "InitializeTheForm - " & Erl & " - " & Err.Description
End Sub


Private Sub InitExporter()

  'Set the interface pointer for the global IExport variable.  The SaveAsType combo box's
  ' ItemData property will return the Priority value that we assigned in the Form_Load event.
  ' Use it as a key to return an exporter object from m_ExportersCol.
270:   Set m_pExport = m_ExportersCol(CStr(cboSaveAsType.ItemData(cboSaveAsType.ListIndex)))
  
  ' Build the file extension string and change the textbox string accordingly.  Resist
  '  temptation to set the exporter object's ExportFileName property here... better to
  '  do that step at the time of the export operation so it will accurately reflect any
  '  changes the user may make to the textbox contents.
276:   m_sFileExtension = Split(Split(cboSaveAsType.Text, "(")(1), ")")(0)
277:   m_sFileExtension = Right(m_sFileExtension, Len(m_sFileExtension) - 1)
  
279:   txtFilename.Text = m_sPath & m_sFileNameRoot & m_sFileExtension
  
End Sub


Private Sub cboSaveAsType_Click()
  
286:   InitExporter
  
End Sub


Private Sub cmdOptions_Click()
  On Error GoTo ErrorHandler


  'Set the Export property of the ExportPropDlg form, and then show the form modally.  You cannot
  ' show the ExportPropDlg form without first setting this property.
  'As users interact with the form, the properties of the assigned exporter object will change
  ' in real-time. When the form ExportPropDlg is dismissed, the exporter object will reflect any
  ' changes the user may have made.
300:   Set frmExportPropDlg.Export = m_pExport
301:   frmExportPropDlg.Show vbModal, Me
  
303:   Set frmExportPropDlg.Export = Nothing
304:   Unload frmExportPropDlg
  
  'The ExportSVG class has a Compression property that changes the value of the Filter property,
  ' and we must syncronize our file extension to account for the possible change.
308:   If TypeOf m_pExport Is IExportSVG Then
309:     cboSaveAsType.List(cboSaveAsType.ListIndex) = Split(m_pExport.Filter, "|")(0)
310:     m_sPath = GetPathFromPathAndFilename(txtFilename)
311:     m_sFileExtension = Split(Split(cboSaveAsType.Text, "(")(1), ")")(0)
312:     m_sFileExtension = Right(m_sFileExtension, Len(m_sFileExtension) - 1)
313:     txtFilename.Text = m_sPath & m_sFileNameRoot & m_sFileExtension
314:   End If
        
  Exit Sub
ErrorHandler:
318:   MsgBox "cmdOptions_Click - " & Erl & " - " & Err.Description
End Sub

Private Sub Form_Initialize()
322:     Set m_pProgress = New ModelessFrame
End Sub

Private Sub Form_Terminate()
326:     Set m_pProgress = New ModelessFrame
End Sub

Private Sub txtFilename_Change()
330:   m_sFileNameRoot = GetRootNameFromPath(txtFilename)
331:   m_sPath = GetPathFromPathAndFilename(txtFilename)
End Sub

Private Sub txtFileName_GotFocus()
335:   txtFilename.SelStart = 0
336:   txtFilename.SelLength = Len(txtFilename.Text)
End Sub


Private Sub cmdExport_Click()
On Error GoTo ErrHand:
  'Get the series properties
343:   If m_pMapSeries Is Nothing Then
344:     MsgBox "Warning, cannot export for the following reason: m_pMapSeries Is Nothing"
    Exit Sub
346:   End If
    
348:   If Me.txtFilename.Text = "" Then
349:     MsgBox "You have not typed in a valid path!!!"
    Exit Sub
351:   End If
  
  Dim bValid As Boolean
354:   bValid = CheckForValidPath(Me.txtFilename.Text)
355:   If bValid = False Then
356:     MsgBox "You have not typed in a valid path!!!"
    Exit Sub
358:   End If

  'Get the Export Object
  Dim pExport As IExport
362:   Set pExport = m_pExport
363:   If pExport Is Nothing Then
364:     MsgBox "No export object!!!"
    Exit Sub
366:   End If

  'Create a Cancel Tracker
  Dim pTC As ITrackCancel
370:   Set pTC = New CancelTracker
371:   pTC.CancelOnClick = False
372:   pTC.CancelOnKeyPress = False
  
  'Assign a cancel tracker object to pExport.
  'This cancel tracker will ignore mouse clicks and key presses so that the export will not be canceled.
376:   Set pExport.TrackCancel = pTC

  'Set the mouse cursor
  Dim pMouse As IMouseCursor
380:   Set pMouse = New MouseCursor
381:   pMouse.SetCursor 2

383:   If GetRegistryValue(HKEY_CURRENT_USER, "Software\ESRI\Export\ExportDlg", "WorkingDirectory", REG_SZ) <> "" Then
384:     SetRegistryValue HKEY_CURRENT_USER, "Software\ESRI\Export\ExportDlg", "WorkingDirectory", REG_SZ, m_sPath
385:   End If
   
387:   If GetRegistryValue(HKEY_CURRENT_USER, "Software\ESRI\Export\ExportDlg", "LastExporter", REG_SZ) <> "" Then
388:     SetRegistryValue HKEY_CURRENT_USER, "Software\ESRI\Export\ExportDlg", "LastExporter", REG_SZ, pExport.Name
389:   End If
  
  Dim pMxDoc As IMxDocument
392:   Set pMxDoc = m_pApp.Document
    
  'Switch to the Layout view if we are not already there
395:   If Not TypeOf pMxDoc.ActiveView Is IPageLayout Then
396:     Set pMxDoc.ActiveView = pMxDoc.PageLayout
397:   End If

  Dim pActiveView As IActiveView
400:   Set pActiveView = pMxDoc.ActiveView
'  pActiveView.ScreenDisplay.DisplayTransformation.ZoomResolution = False

  'Save the previous output quality so that I can be restored later.
  Dim pOutputRasterSettings As IOutputRasterSettings
  Dim iPrevOutputImageQuality As Long
406:   Set pOutputRasterSettings = pActiveView.ScreenDisplay.DisplayTransformation
407:   iPrevOutputImageQuality = pOutputRasterSettings.ResampleRatio

  'Disable the cancel button
410:   Me.cmdCancel.Enabled = False

  '****************************************************
  'Create a collection of all of the selected map pages
  '****************************************************
  Dim i As Long
  Dim PagesToExport As Collection
417:   Set PagesToExport = New Collection
 
  '*******If we are exporting a page *******
420:   If Not m_pMapPage Is Nothing Then
    'MsgBox "exporting a page"
422:     PagesToExport.Add m_pMapPage
    
424:     ExportPagesCollections PagesToExport, m_pMapSeries, pExport, pActiveView, ""
    
  '*******If we are exporting a series *******
427:   ElseIf Not m_pMapSeries Is Nothing And m_pMapPage Is Nothing And m_pMapBook Is Nothing Then
    'MsgBox "exporting a series"
429:     If Me.optAll.value = True Then
430:       For i = 0 To m_pMapSeries.PageCount - 1
431:         If (Me.chkDisabled.value <> 1) Or (m_pMapSeries.Page(i).EnablePage) Then
432:             PagesToExport.Add m_pMapSeries.Page(i)
433:         End If
434:       Next i
435:     ElseIf Me.optPages.value = True Then
      'parse out the pages to export
      Dim bDisabled As Boolean
438:       bDisabled = False
439:       If chkDisabled.value = 1 Then bDisabled = True
440:       Set PagesToExport = ParseOutPages(Me.txtPages.Text, m_pMapSeries, bDisabled)
441:     End If
    
443:     ExportPagesCollections PagesToExport, m_pMapSeries, pExport, pActiveView, ""
  
  '*******If we are exporting a map book *******
446:   ElseIf Not m_pMapBook Is Nothing Then
  'MsgBox "exporting a map book"
    Dim pMapSeries As IDSMapSeries
    Dim count As Long
450:     For i = 0 To m_pMapBook.ContentCount - 1
451:       Set PagesToExport = New Collection
452:       Set pMapSeries = m_pMapBook.ContentItem(i)
    
454:       For count = 0 To pMapSeries.PageCount - 1
455:         If Me.chkDisabled.value = 1 Then
456:           If pMapSeries.Page(count).EnablePage Then
457:             PagesToExport.Add pMapSeries.Page(count)
458:           End If
459:         Else
460:             PagesToExport.Add pMapSeries.Page(count)
461:         End If
462:       Next count
463:       ExportPagesCollections PagesToExport, pMapSeries, pExport, pActiveView, "_series_" & i
464:     Next i
465:   End If

'****After Exporting the maps****

'  pActiveView.ScreenDisplay.DisplayTransformation.ZoomResolution = True
470:   If TypeOf pExport Is IOutputCleanup Then
    Dim pCleanup As IOutputCleanup
472:     Set pCleanup = pExport
473:     pCleanup.Cleanup
474:   End If
  
  'Restore the previous output quality
477:   SetOutputQuality pActiveView, iPrevOutputImageQuality

  Dim pSeriesProps As IDSMapSeriesProps
480:   Set pSeriesProps = m_pMapSeries

  'Return to the active page
  Dim lPageIndex As Long
484:   lPageIndex = (m_pMapSeries.CurrentPageNumber - pSeriesProps.StartNumber)
485:   modGeneralFunctions.ViewPage m_pApp, m_pMapSeries, lPageIndex

487:   lblStatus.Caption = ""
488:   Set m_pMapBook = Nothing
489:   Set m_pMapPage = Nothing
490:   Set m_pMapSeries = Nothing
491:   m_pExportFrame.Visible = False
  
  'Enable the cancel button
494:   Me.cmdCancel.Enabled = True

496:   Unload Me

  Exit Sub
ErrHand:
500:   lblStatus.Caption = ""
  'Enable the cancel button
502:   Me.cmdCancel.Enabled = True
503:   MsgBox "cmdExport_Click - " & Erl & " - " & Err.Description
End Sub

'This function takes a collection of Page objects as input and exports them.
Private Sub ExportPagesCollections(PagesToExport As Collection, pMapSeries As IDSMapSeries, pExport As IExport, pActiveView As IActiveView, sSeriesPrefix As String)
On Error GoTo ErrHand:
    'If there are no pages to export, then exit
510:     If (PagesToExport Is Nothing) Or (PagesToExport.count = 0) Then
511:       MsgBox "Warning: No pages to export."
      Exit Sub
513:     End If

    'From the map series, update the global options.
    Dim pSeriesOpts As IDSMapSeriesOptions
    Dim pSeriesOpts2 As IDSMapSeriesOptions2
518:     Set pSeriesOpts = pMapSeries
519:     Set pSeriesOpts2 = pSeriesOpts
520:     If pSeriesOpts2.ClipData > 0 Then
521:       g_bClipFlag = True
522:     End If
523:     If pSeriesOpts.RotateFrame Then
524:       g_bRotateFlag = True
525:     End If
526:     If pSeriesOpts.LabelNeighbors Then
527:       g_bLabelNeighbors = True
528:     End If

    'Get the Series Properties Object
    Dim pSeriesProps As IDSMapSeriesProps
532:     Set pSeriesProps = pMapSeries

    'Create a Cancel Tracker
    Dim pTC As ITrackCancel
536:     Set pTC = New CancelTracker
537:     pTC.CancelOnClick = False
538:     pTC.CancelOnKeyPress = False
    
    'Initialize the progress bar
    Dim pProgress As frmProgress
542:     Set pProgress = New frmProgress
543:     m_pProgress.Create pProgress
544:     pProgress.ProgressBar1.Min = 0
545:     pProgress.ProgressBar1.Max = PagesToExport.count
546:     pProgress.ProgressBar1.value = 0
547:     pProgress.lblInformation.Caption = "Exporting ..." & sSeriesPrefix & " (Page 0 of " & PagesToExport.count & ")"
548:     pProgress.cmdCancel.Visible = True        ' User can cancel at any time
549:     m_pProgress.Visible = True
550:     pProgress.Refresh

'    'Hide the export dialog
'    Me.Hide

    'About to loop through pages to export.
    Dim pMapPage As IDSMapPage
    Dim sExportFile As String
    Dim ExportFrame As tagRECT
    Dim hdc As Long
    Dim sFileName As String
    Dim sFileExt As String
562:     sFileName = m_sPath & m_sFileNameRoot
563:     sFileExt = m_sFileExtension

    'Loop through pages to export.
566:     For i = 1 To PagesToExport.count
567:         DoEvents 'Share some CPU time with the user interface to all user-events to be handled.
568:         pProgress.Refresh
569:         If pProgress.Cancelled Then
570:             pProgress.Cancelled = False 'Reset the form
571:             Exit For
572:         End If
                
        'MsgBox "Looping Through Pages to Export"
575:         Set pMapPage = PagesToExport.Item(i)
576:         If pMapPage Is Nothing Then GoTo EndOfFor

578:         DrawPage m_pApp, m_pMapSeries, pMapPage.PageNumber - pSeriesProps.StartNumber
   
580:         sExportFile = sFileName & sSeriesPrefix & "_" & pMapPage.PageName & sFileExt
581:         lblStatus.Caption = "Exporting to " & m_sFileNameRoot & sSeriesPrefix & "_" & pMapPage.PageName & sFileExt & " ..."
        
        'Refresh the progress bar
584:         pProgress.ProgressBar1.value = i - 1
585:         pProgress.lblInformation.Caption = "Exporting ..." & sSeriesPrefix & " (Page " & i & " of " & PagesToExport.count & ")"
    
587:         DoEvents 'Share some CPU time with the user interface to all user-events to be handled.
588:         pProgress.Refresh
589:         If pProgress.Cancelled Then
590:             pProgress.Cancelled = False 'Reset the form
591:             Exit For
592:         End If
      
594:         SetupToExport pExport, pExport.Resolution, ExportFrame, pActiveView, sExportFile
      
        'Do the export
597:         hdc = pExport.StartExporting
598:         pActiveView.Output hdc, pExport.Resolution, ExportFrame, Nothing, pTC
599:         pMapPage.LastOutputted = Format(Date, "mm/dd/yyyy")
600:         pExport.FinishExporting
601:         pExport.Cleanup
        'MsgBox "After exporting and cleaning up."
EndOfFor:
604:     Next i

    'Hide the progress bar
607:     m_pProgress.Visible = False

    Exit Sub
ErrHand:
611:     MsgBox "ExportPagesCollections - " & Erl & " - " & Err.Description
612:     m_pProgress.Visible = False
End Sub

Public Sub SetupToExport(ByRef pExport As IExport, ByRef dpi As Integer, ByRef ExportFrame As tagRECT, pActiveView As IActiveView, sExportFileName As String)
  On Error GoTo ErrorHandler
  
  Dim pEnv As IEnvelope, pPageLayout As IPageLayout, pPage As IPage
  Dim dXmax As Double, dYmax As Double
  Dim pOutputRasterSettings As IOutputRasterSettings

622:    Set pEnv = New Envelope
'   pActiveView.ScreenDisplay.DisplayTransformation.Resolution = pExport.Resolution
  'Setup the Export
625:   ExportFrame = pActiveView.ExportFrame

627:   Set pPageLayout = pActiveView
628:   Set pPage = pPageLayout.Page
  
630:   If pPage.Units <> esriInches Then
631:     pPage.Units = esriInches
632:   End If
  
634:   pPage.QuerySize dXmax, dYmax
635:   pEnv.PutCoords 0, 0, dXmax * pExport.Resolution, dYmax * pExport.Resolution

'Commented out code removes a quarter of a unit, most likely an inch, from the extent to make it
'fit better on the page
'  ExportFrame.Top = pExport.Resolution * 0.25
'  ExportFrame.Right = (dXmax - 0.25) * pExport.Resolution
641:   ExportFrame.Right = dXmax * pExport.Resolution
642:   ExportFrame.bottom = dYmax * pExport.Resolution
  
644:   ExportFrame.Left = 0
645:   ExportFrame.Top = 0
            
647:   With pExport
648:     .PixelBounds = pEnv
649:     .ExportFileName = sExportFileName
650:   End With

  
  ' Output Image Quality of the export.  The value here will only be used if the export
  '  object is a format that allows setting of Output Image Quality, i.e. a vector exporter.
  '  The value assigned to ResampleRatio should be in the range 1 to 5.
  '  1 (esriRasterOutputBest) corresponds to "Best", 5 corresponds to "Fast"
657:   If TypeOf pExport Is IOutputRasterSettings Then
    ' for vector formats, get the ResampleRatio from the export object and call SetOutputQuality
    '   to control drawing of raster layers at export time
660:     Set pOutputRasterSettings = pExport
661:     SetOutputQuality pActiveView, pOutputRasterSettings.ResampleRatio
662:     Set pOutputRasterSettings = Nothing
663:   Else
    'always set the output quality of the display to 1 (esriRasterOutputBest) for image export formats
665:     SetOutputQuality pActiveView, esriRasterOutputBest
666:   End If
  
  
  
  Exit Sub
ErrorHandler:
672:   MsgBox "SetupToExport - " & Erl & " - " & Err.Description
End Sub


Public Function ConvertToPixels(sOrient As String, pExport As IExport) As Double
On Error GoTo ErrHand:
  Dim pixelExtent As Long
  Dim pDT As IDisplayTransformation
  Dim deviceRECT As tagRECT
  Dim pMxDoc As IMxDocument
  
683:   Set pMxDoc = m_pApp.Document
684:   Set pDT = pMxDoc.ActiveView.ScreenDisplay.DisplayTransformation
685:   deviceRECT = pDT.DeviceFrame
  
687:   If sOrient = "Height" Then
688:     pixelExtent = Abs(deviceRECT.Top - deviceRECT.bottom)
689:   ElseIf sOrient = "Width" Then
690:     pixelExtent = Abs(deviceRECT.Top - deviceRECT.bottom)
691:   End If
  
693:   ConvertToPixels = (pExport.Resolution * (pixelExtent / pDT.Resolution))
  
  Exit Function
ErrHand:
697:   MsgBox "ConvertToPixels - " & Erl & " - " & Err.Description
End Function

Private Sub Form_Load()
701:   chkDisabled.value = 1

  'MsgBox "Loaded frmExport"
End Sub

Private Function CheckForValidPath(sPathName As String) As Boolean
  On Error GoTo ErrorHandler

709:   CheckForValidPath = False
  
  Dim aPath() As String
712:       aPath = Split(sPathName, ".")

714:   If UBound(aPath) = 0 Then
    Exit Function
716:   ElseIf UBound(aPath) = 1 Then
    
    Dim sPath As String
    Dim lPos As Long
    
721:       lPos = InStrRev(sPathName, "\")
722:       sPath = Left$(sPathName, (Len(sPathName) - (Len(sPathName) - lPos + 1)))
      
724:       If Dir(sPath, vbDirectory) <> "" Then
725:         CheckForValidPath = True
        Exit Function
727:       Else
        Exit Function
729:       End If
      
731:   ElseIf UBound(aPath) > 1 Then
    Exit Function
733:   End If
  
  Exit Function
ErrorHandler:
737:   MsgBox "CheckForValidPath - " & Erl & " - " & Err.Description
End Function


Public Sub SetOutputQuality(pActiveView As IActiveView, ByVal lOutputQuality As Long)
  Dim pMap As IMap
  Dim pGraphicsContainer As IGraphicsContainer
  Dim pElement As IElement
  Dim pOutputRasterSettings As IOutputRasterSettings
  Dim pMapFrame As IMapFrame
  Dim pTmpActiveView As IActiveView
  
  
750:   If TypeOf pActiveView Is IMap Then
751:     Set pOutputRasterSettings = pActiveView.ScreenDisplay.DisplayTransformation
752:     pOutputRasterSettings.ResampleRatio = lOutputQuality
753:   ElseIf TypeOf pActiveView Is IPageLayout Then
    
    'assign ResampleRatio for PageLayout
756:     Set pOutputRasterSettings = pActiveView.ScreenDisplay.DisplayTransformation
757:     pOutputRasterSettings.ResampleRatio = lOutputQuality
    
    'and assign ResampleRatio to the Maps in the PageLayout
760:     Set pGraphicsContainer = pActiveView
761:     pGraphicsContainer.Reset
762:     Set pElement = pGraphicsContainer.Next
763:     Do While Not pElement Is Nothing
764:       If TypeOf pElement Is IMapFrame Then
765:         Set pMapFrame = pElement
766:         Set pTmpActiveView = pMapFrame.Map
767:         Set pOutputRasterSettings = pTmpActiveView.ScreenDisplay.DisplayTransformation
768:         pOutputRasterSettings.ResampleRatio = lOutputQuality
769:       End If
770:       DoEvents
771:       Set pElement = pGraphicsContainer.Next
772:     Loop
773:     Set pMap = Nothing
774:     Set pMapFrame = Nothing
775:     Set pGraphicsContainer = Nothing
776:     Set pTmpActiveView = Nothing
777:   End If
778:   Set pOutputRasterSettings = Nothing
  
End Sub


Private Sub Form_Unload(Cancel As Integer)
784:   Set m_pMapPage = Nothing
785:   Set m_pMapSeries = Nothing
786:   Set m_pMapBook = Nothing
787:   Set m_pApp = Nothing
788:   Set m_pExport = Nothing
789:   Set m_pExportFrame = Nothing
790:   Set m_ExportersCol = Nothing
End Sub

Public Function GetMxdName() As String
On Error GoTo ErrHand
  Dim pTemplates As ITemplates
  Dim lTempCount As Long
  Dim strDocPath As String
  
799:   Set pTemplates = Application.Templates
800:   lTempCount = pTemplates.count
  
  ' The document is always the last item
803:   strDocPath = pTemplates.Item(lTempCount - 1)
804:   GetMxdName = Split(strDocPath, "\")(UBound(Split(strDocPath, "\")))
  Exit Function
ErrHand:
807:   MsgBox "GetMxdName - " & Erl & " - " & Err.Description
End Function

Public Function GetRootNameFromPath(sPathAndFilename As String) As String
On Error GoTo ErrHand

  Dim sRootName As String
814:   sRootName = Split(sPathAndFilename, "\")(UBound(Split(sPathAndFilename, "\")))
815:   sRootName = Split(sRootName, ".")(0)
816:   GetRootNameFromPath = sRootName
  Exit Function
ErrHand:
819:   MsgBox "GetRootNameFromPath - " & Erl & " - " & Err.Description
End Function

Public Function GetPathFromPathAndFilename(sPathAndFilename As String) As String
On Error GoTo ErrHand

  Dim sPathName As String
  Dim sRootName As String
827:   sRootName = Split(sPathAndFilename, "\")(UBound(Split(sPathAndFilename, "\")))
828:   sPathName = Left(sPathAndFilename, Len(sPathAndFilename) - Len(sRootName))

830:   GetPathFromPathAndFilename = sPathName
  Exit Function
ErrHand:
833:   MsgBox "GetPathFromPathAndFilename - " & Erl & " - " & Err.Description
End Function


' Read a Registry value.
' Use KeyName = "" for the default value.
' Supports only DWORD, SZ, and BINARY value types.

Function GetRegistryValue(ByVal hKey As Long, ByVal KeyName As String, _
    ByVal ValueName As String, ByVal KeyType As Integer, _
    Optional DefaultValue As Variant = Empty) As Variant

    Dim handle As Long, resLong As Long
    Dim resString As String, length As Long
    Dim resBinary() As Byte
    
    ' Prepare the default result.
850:     GetRegistryValue = DefaultValue
    ' Open the key, exit if not found.
    If RegOpenKeyEx(hKey, KeyName, 0, KEY_READ, handle) Then Exit Function
    
    Select Case KeyType
        Case REG_DWORD
            ' Read the value, use the default if not found.
857:             If RegQueryValueEx(handle, ValueName, 0, REG_DWORD, _
                resLong, 4) = 0 Then
859:                 GetRegistryValue = resLong
860:             End If
        Case REG_SZ
862:             length = 1024: resString = Space$(length)
863:             If RegQueryValueEx(handle, ValueName, 0, REG_SZ, _
                ByVal resString, length) = 0 Then
                ' If value is found, trim characters in excess.
866:                 GetRegistryValue = Left$(resString, length - 1)
867:             End If
        Case REG_BINARY
869:             length = 4096
            ReDim resBinary(length - 1) As Byte
871:             If RegQueryValueEx(handle, ValueName, 0, REG_BINARY, _
                resBinary(0), length) = 0 Then
873:                 GetRegistryValue = resBinary()
874:             End If
        Case Else
876:             Err.Raise 1001, , "Unsupported value type"
877:     End Select
    
879:     RegCloseKey handle
End Function

' Write / Create a Registry value.
' Use KeyName = "" for the default value.
' Supports only DWORD, SZ, REG_MULTI_SZ, and BINARY value types.

Sub SetRegistryValue(ByVal hKey As Long, ByVal KeyName As String, ByVal ValueName As String, ByVal KeyType As Integer, value As Variant)
    Dim handle As Long, lngValue As Long
    Dim strValue As String
    Dim binValue() As Byte, length As Long
    
    ' Open the key, exit if not found.
    If RegOpenKeyEx(hKey, KeyName, 0, KEY_WRITE, handle) Then Exit Sub
    
    Select Case KeyType
        Case REG_DWORD
896:             lngValue = value
897:             RegSetValueEx handle, ValueName, 0, KeyType, lngValue, 4
        Case REG_SZ
899:             strValue = value
900:             RegSetValueEx handle, ValueName, 0, KeyType, ByVal strValue, Len(strValue)
        Case REG_MULTI_SZ
902:             strValue = value
903:             RegSetValueEx handle, ValueName, 0, KeyType, ByVal strValue, Len(strValue)
        Case REG_BINARY
905:             binValue = value
906:             length = UBound(binValue) - LBound(binValue) + 1
907:             RegSetValueEx handle, ValueName, 0, KeyType, binValue(LBound(binValue)), length
908:     End Select
    
    ' Close the key.
911:     RegCloseKey handle
End Sub
