Attribute VB_Name = "modSharedConstants"
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

'Author: Sam Falchook
'USACE, MVN
'Creation Date: 11/12/2008
'
'Purpose: This module contains constants that are shared by multiple projects in the group project.


Option Explicit

Public Const TAG_CONST_DATE = "DSMAPBOOK - DATE"
Public Const TAG_CONST_TITLE = "DSMAPBOOK - TITLE"
Public Const TAG_CONST_PAGENUMBER = "DSMAPBOOK - PAGENUMBER"
Public Const TAG_CONST_EXTRAITEM = "DSMAPBOOK - EXTRAITEM"
Public Const TAG_CONST_THISPAGEONLY = "DSMAPBOOK - THISPAGEONLY"
Public Const TAG_CONST_ALLPAGESBUTTHIS = "DSMAPBOOK - ALLPAGESBUTTHIS"
Public Const TAG_CONST_DATAGRAPH = "DSMAPBOOK - DATAGRAPH"
Public Const FEATURE_LAYER_UID = "{E156D7E5-22AF-11D3-9F99-00C04F6BC78E}" 'UID for IFeatureLayer
Public Const DATA_LAYER_UID = "{6CA416B1-E160-11D2-9F4E-00C04F6BC78E}" 'UID for IDataLayer
