VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "tmpPageClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

' Copyright 2006 ESRI
'
' All rights reserved under the copyright laws of the United States
' and applicable international laws, treaties, and conventions.
'
' You may freely redistribute and use this sample code, with or
' without modification, provided you include the original copyright
' notice and use restrictions.
'
' See use restrictions at /arcgis/developerkit/userestrictions.

Option Explicit

Dim m_sPageName As String
Dim m_dRotation As Double
Dim m_dScale As Double
Dim m_dShape As IPolygon
Dim m_fromStat As Double
Dim m_toStat As Double

Public Property Get PageName() As String
23:   PageName = m_sPageName
End Property

Public Property Let PageName(RHS As String)
27:   m_sPageName = RHS
End Property

Public Property Get PageRotation() As Double
31:   PageRotation = m_dRotation
End Property

Public Property Let PageRotation(RHS As Double)
35:   m_dRotation = RHS
End Property

Public Property Get PageScale() As Double
39:   PageScale = m_dScale
End Property

Public Property Let PageScale(RHS As Double)
43:   m_dScale = RHS
End Property

Public Property Get PageShape() As IPolygon
47:   Set PageShape = m_dShape
End Property

Public Property Set PageShape(RHS As IPolygon)
51:   Set m_dShape = RHS
End Property

Public Property Let FromStation(RHS As Double)
55:     m_fromStat = RHS
End Property

Public Property Get FromStation() As Double
59:     FromStation = m_fromStat
End Property

Public Property Let ToStation(RHS As Double)
63:     m_toStat = RHS
End Property

Public Property Get ToStation() As Double
67:     ToStation = m_toStat
End Property
