VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DSMapBookBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

' Copyright 2006 ESRI
'
' All rights reserved under the copyright laws of the United States
' and applicable international laws, treaties, and conventions.
'
' You may freely redistribute and use this sample code, with or
' without modification, provided you include the original copyright
' notice and use restrictions.
'
' See use restrictions at /arcgis/developerkit/userestrictions.

'
' Toolbar containing the Split and Combine commands.
'
Option Explicit

Implements IToolBarDef

Private Property Get IToolBarDef_Caption() As String
21:   IToolBarDef_Caption = "USACE JAMB"
End Property

Private Sub IToolBarDef_GetItemInfo(ByVal pos As Long, ByVal itemDef As IItemDef)
  Select Case pos
  Case 0
27:     itemDef.ID = "JAMB_Front_End.CreateMapBook"
  Case 1
29:     itemDef.ID = "JAMB_Front_End.PageIdentifier"
  Case 2
31:     itemDef.ID = "JAMB_Front_End.clsMapGridButton"
  Case 3
33:     itemDef.ID = "JAMB_Front_End.clsStripMapButton"
  Case 4
35:     itemDef.ID = "JAMB_Front_End.clsHelpButton"
36:   End Select
End Sub

Private Property Get IToolBarDef_ItemCount() As Long
40:   IToolBarDef_ItemCount = 5
End Property

Private Property Get IToolBarDef_name() As String
44:   IToolBarDef_name = "JAMB_Front_End.USACE_JAMB_MapSeriesBar"
End Property
