VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DSMapBookTab"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

' Copyright 2006 ESRI
'
' All rights reserved under the copyright laws of the United States
' and applicable international laws, treaties, and conventions.
'
' You may freely redistribute and use this sample code, with or
' without modification, provided you include the original copyright
' notice and use restrictions.
'
' See use restrictions at /arcgis/developerkit/userestrictions.

Option Explicit

Private m_pDoc As IMxDocument
Private m_pMap As IMap
Private m_bIsVisible As Boolean
Private m_ContextItem As Variant
Private m_SelectedItem As Variant
Private m_ShowLines As Boolean

Implements IContentsView

Private Sub Class_Initialize()
25:   m_bIsVisible = True
26:   Load g_pFrmMapSeries
End Sub

Private Sub Class_Terminate()
30:   Unload g_pFrmMapSeries
31:   Set g_pFrmMapSeries = Nothing
End Sub

Private Sub IContentsView_Activate(ByVal parentHWND As esriSystem.OLE_HANDLE, ByVal Document As IMxDocument)

  'From Al
37:   RemoveContextMenu g_pFrmMapSeries.tvwMapBook.hwnd
End Sub

Private Sub IContentsView_AddToSelectedItems(ByVal Item As Variant)

End Sub

Private Property Let IContentsView_ContextItem(ByVal RHS As Variant)
On Error GoTo ErrHand:
46:   m_ContextItem = RHS
  
  Exit Property
ErrHand:
50:   MsgBox "Let IContentsView_ContextItem - " & Erl & " - " & Err.Description
End Property

Private Property Get IContentsView_ContextItem() As Variant
On Error GoTo ErrHand:
55:   IContentsView_ContextItem = m_ContextItem
  
  Exit Property
ErrHand:
59:   MsgBox "Get IContentsView_ContextItem - " & Erl & " - " & Err.Description
End Property

Private Sub IContentsView_Deactivate()
63:   RemoveContextMenuSink g_pFrmMapSeries.tvwMapBook.hwnd
End Sub

Private Property Get IContentsView_hWnd() As esriSystem.OLE_HANDLE
67:   IContentsView_hWnd = g_pFrmMapSeries.tvwMapBook.hwnd
End Property

Private Property Get IContentsView_Name() As String
71:   IContentsView_Name = "USACE JAMB"
End Property

Private Property Let IContentsView_ProcessEvents(ByVal RHS As Boolean)

End Property

Private Sub IContentsView_Refresh(ByVal Item As Variant)

End Sub

Private Sub IContentsView_RemoveFromSelectedItems(ByVal Item As Variant)

End Sub

Private Property Let IContentsView_SelectedItem(ByVal RHS As Variant)
On Error GoTo ErrHand:
88:   m_SelectedItem = RHS
  
  Exit Property
ErrHand:
92:   MsgBox "Let IContentsView_SelectedItem - " & Erl & " - " & Err.Description
End Property

Private Property Get IContentsView_SelectedItem() As Variant
On Error GoTo ErrHand:
97:   IContentsView_SelectedItem = m_SelectedItem
  
  Exit Property
ErrHand:
101:   MsgBox "Get IContentsView_SelectedItem - " & Erl & " - " & Err.Description
End Property

Private Property Let IContentsView_ShowLines(ByVal RHS As Boolean)
105:   m_ShowLines = RHS
End Property

Private Property Get IContentsView_ShowLines() As Boolean
109:   IContentsView_ShowLines = m_ShowLines
End Property

Private Property Let IContentsView_Visible(ByVal RHS As Boolean)
113:   m_bIsVisible = RHS
End Property

Private Property Get IContentsView_Visible() As Boolean
117:   IContentsView_Visible = m_bIsVisible
End Property

