VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmCreateIndex 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Create Index"
   ClientHeight    =   4575
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   4830
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4575
   ScaleWidth      =   4830
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog codOutput 
      Left            =   90
      Top             =   4020
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Frame Frame1 
      BorderStyle     =   0  'None
      Caption         =   "Frame1"
      Height          =   1125
      Left            =   60
      TabIndex        =   10
      Top             =   2820
      Width           =   4515
      Begin VB.TextBox txtPageNumber 
         Height          =   315
         Left            =   3720
         TabIndex        =   15
         Top             =   660
         Width           =   465
      End
      Begin VB.OptionButton optIndex 
         Caption         =   "Page Number (Number shown on Series list)"
         Height          =   225
         Index           =   1
         Left            =   810
         TabIndex        =   13
         Top             =   420
         Width           =   3405
      End
      Begin VB.OptionButton optIndex 
         Caption         =   "Page Label"
         Height          =   225
         Index           =   0
         Left            =   810
         TabIndex        =   12
         Top             =   60
         Width           =   1155
      End
      Begin VB.Label Label3 
         Caption         =   "Add this value to each page number:"
         Height          =   255
         Index           =   1
         Left            =   1080
         TabIndex        =   14
         Top             =   690
         Width           =   2625
      End
      Begin VB.Label Label3 
         Caption         =   "Index by:"
         Height          =   255
         Index           =   0
         Left            =   60
         TabIndex        =   11
         Top             =   30
         Width           =   735
      End
   End
   Begin VB.ComboBox cmbFieldName 
      Height          =   315
      Left            =   870
      Style           =   2  'Dropdown List
      TabIndex        =   8
      Top             =   1860
      Width           =   3405
   End
   Begin VB.ComboBox cmbLayer 
      Height          =   315
      Left            =   870
      Style           =   2  'Dropdown List
      TabIndex        =   7
      Top             =   1410
      Width           =   3405
   End
   Begin VB.CommandButton cmdBrowse 
      Height          =   315
      Left            =   4350
      Picture         =   "frmCreateIndex.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   4
      Top             =   2310
      Width           =   345
   End
   Begin VB.TextBox txtOutput 
      Enabled         =   0   'False
      Height          =   315
      Left            =   870
      TabIndex        =   2
      Top             =   2310
      Width           =   3375
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   4050
      TabIndex        =   1
      Top             =   4110
      Width           =   735
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Height          =   375
      Left            =   3240
      TabIndex        =   0
      Top             =   4110
      Width           =   735
   End
   Begin VB.Label Label2 
      Caption         =   "Field:"
      Height          =   255
      Index           =   1
      Left            =   390
      TabIndex        =   9
      Top             =   1890
      Width           =   405
   End
   Begin VB.Label Label2 
      Caption         =   "Layer:"
      Height          =   255
      Index           =   0
      Left            =   330
      TabIndex        =   6
      Top             =   1440
      Width           =   465
   End
   Begin VB.Label Label1 
      Caption         =   $"frmCreateIndex.frx":047A
      Height          =   1215
      Left            =   60
      TabIndex        =   5
      Top             =   90
      Width           =   4665
   End
   Begin VB.Label lblExportTo 
      Caption         =   "Output to:"
      Height          =   255
      Left            =   60
      TabIndex        =   3
      Top             =   2340
      Width           =   735
   End
End
Attribute VB_Name = "frmCreateIndex"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

' Copyright 2006 ESRI
'
' All rights reserved under the copyright laws of the United States
' and applicable international laws, treaties, and conventions.
'
' You may freely redistribute and use this sample code, with or
' without modification, provided you include the original copyright
' notice and use restrictions.
'
' See use restrictions at /arcgis/developerkit/userestrictions.

Public m_pApp As IApplication
Private m_pMasterColl As Collection

Private Sub cmbLayer_Click()
On Error GoTo ErrHand:
  Dim pFeatLayer As IFeatureLayer, pFields As IFields, lLoop As Long
  
20:   Set pFeatLayer = FindFeatureLayerByName(cmbLayer.List(cmbLayer.ListIndex), m_pApp)
  If pFeatLayer Is Nothing Then Exit Sub
  
23:   cmbFieldName.Clear
24:   Set pFields = pFeatLayer.FeatureClass.Fields
25:   For lLoop = 0 To pFields.FieldCount - 1
26:     If pFields.Field(lLoop).Type = esriFieldTypeString Then
27:       cmbFieldName.AddItem pFields.Field(lLoop).Name
28:     End If
29:   Next lLoop
30:   If cmbFieldName.ListCount > 0 Then
31:     cmbFieldName.ListIndex = 0
32:   End If
  
34:   CheckSettings

  Exit Sub
ErrHand:
38:   MsgBox "cmbLayer_Click - " & Erl & " - " & Err.Description
End Sub

Private Sub cmdBrowse_Click()
On Error GoTo ErrHand:
43:   codOutput.DialogTitle = "Specify output file to create"
44:   codOutput.Filter = "(*.txt)|*.txt"
45:   codOutput.Flags = cdlOFNOverwritePrompt
46:   codOutput.ShowSave
47:   If codOutput.FileName = "" Then
48:     txtOutput.Text = ""
49:   Else
50:     txtOutput.Text = codOutput.FileName
51:   End If
  
53:   CheckSettings
  
  Exit Sub
ErrHand:
57:   MsgBox "cmdBrowse_Click - " & Erl & " - " & Err.Description
End Sub

Private Sub cmdCancel_Click()
61:   Set m_pApp = Nothing
62:   Unload Me
End Sub

Private Sub cmdOK_Click()
'This routine will create the index and write it out to the specified file.
On Error GoTo ErrHand:
  Dim pDoc As IMxDocument, pMap As IMap, lLoop As Long
  Dim pFeatLayer As IFeatureLayer, pMapBook As IDSMapBook, pSeries As IDSMapSeries
  Dim pPage As IDSMapPage, pColl As Collection
  Dim sPageId As String, sFieldName As String
  Dim sTempVal As String, sTempPage As String, lPos As Long
  Dim sPrev As String, sTemp As String, sOutput As String
  Dim pOutputPages As Collection, lLoop2 As Long, sOutputPages As String

  
  
78:   Set pMapBook = GetMapBookExtension(m_pApp)
79:   If pMapBook Is Nothing Then
80:     MsgBox "Map book was not found!!!"
    Exit Sub
82:   End If
  
  'Get the index layer
85:   Set pFeatLayer = FindFeatureLayerByName(cmbLayer.List(cmbLayer.ListIndex), m_pApp)
86:   If pFeatLayer Is Nothing Then
87:     MsgBox "Count not find the index layer for some reason!!!"
    Exit Sub
89:   End If
90:   sFieldName = cmbFieldName.List(cmbFieldName.ListIndex)
91:   Set pSeries = pMapBook.ContentItem(0)
  
  'Setup the progress bar
94:   Screen.MousePointer = vbHourglass
95:   With m_pApp.StatusBar.ProgressBar
96:     .Message = "Index Creation:"
97:     .MaxRange = pSeries.PageCount
98:     .StepValue = 1
99:     .Position = 1
100:     .Show
101:   End With
  
  'Loop through the pages returning a collection of the attribute values returned by the
  'features found on the page.  Add the page collections to the master.
105:   Set m_pMasterColl = New Collection
106:   For lLoop = 0 To pSeries.PageCount - 1
107:     Set pPage = pSeries.Page(lLoop)
108:     Set pColl = pPage.IndexPage(pFeatLayer, sFieldName)
109:     If optIndex(0).value Then
110:       sPageId = pPage.PageName
111:     Else
112:       sPageId = CStr(lLoop + 1 + CLng(txtPageNumber.Text))
113:     End If
114:     AddPageToMasterCollection pColl, sPageId
    
116:     m_pApp.StatusBar.ProgressBar.Step
117:   Next lLoop
  
  'Dump the master collection out to the specified file
120:   sPrev = ""
121:   Open txtOutput.Text For Output As #1
122:   For lLoop = 1 To m_pMasterColl.count
123:     sTemp = m_pMasterColl.Item(lLoop)
124:     lPos = InStr(1, sTemp, "-$$$$-")
125:     sTempVal = Left(sTemp, lPos - 1)
126:     sTempPage = Mid(sTemp, lPos + 6)
127:     If sPrev = "" Then
128:       Set pOutputPages = New Collection
129:       sOutput = sTempVal
130:       pOutputPages.Add sTempPage, sTempPage
131:       sPrev = sTempVal
132:     ElseIf sPrev = sTempVal Then
133:       If optIndex(0).value Then
134:         pOutputPages.Add sTempPage, sTempPage
135:       Else
136:         For lLoop2 = 1 To pOutputPages.count
137:           If CLng(sTempPage) < CLng(pOutputPages.Item(lLoop2)) Then
138:             pOutputPages.Add sTempPage, sTempPage, lLoop2
139:             Exit For
140:           End If
141:           If lLoop2 = pOutputPages.count Then
142:             pOutputPages.Add sTempPage, sTempPage
143:           End If
144:         Next lLoop2
145:       End If
146:     Else
147:       For lLoop2 = 1 To pOutputPages.count
148:         If lLoop2 = 1 Then
149:           sOutputPages = pOutputPages.Item(lLoop2)
150:         Else
151:           sOutputPages = sOutputPages & ", " & pOutputPages.Item(lLoop2)
152:         End If
153:       Next lLoop2
154:       Print #1, sOutput & ": " & sOutputPages
155:       sOutput = sTempVal
156:       Set pOutputPages = New Collection
157:       pOutputPages.Add sTempPage, sTempPage
158:       sPrev = sTempVal
159:     End If
160:     If lLoop = m_pMasterColl.count Then
161:       For lLoop2 = 1 To pOutputPages.count
162:         If lLoop2 = 1 Then
163:           sOutputPages = pOutputPages.Item(lLoop2)
164:         Else
165:           sOutputPages = sOutputPages & ", " & pOutputPages.Item(lLoop2)
166:         End If
167:       Next lLoop2
168:       Print #1, sOutput & ": " & sOutputPages
169:     End If
170:   Next lLoop
171:   Close #1
  
173:   m_pApp.StatusBar.ProgressBar.Hide
174:   Screen.MousePointer = vbNormal
175:   Unload Me
  
  Exit Sub
ErrHand:
179:   Screen.MousePointer = vbNormal
180:   MsgBox "cmdOK_Click - " & Erl & " - " & Err.Description
End Sub

Private Sub AddPageToMasterCollection(pColl As Collection, sPageId As String)
On Error GoTo ErrHand:
  Dim lLoop As Long, sValue As String, lLoop2 As Long, lStart As Long
186:   lStart = 1
187:   If m_pMasterColl.count = 0 Then
188:     For lLoop = 1 To pColl.count
189:       sValue = pColl.Item(lLoop) & "-$$$$-" & sPageId
190:       m_pMasterColl.Add sValue, sValue
191:     Next lLoop
192:   Else
193:     For lLoop = 1 To pColl.count
194:       sValue = pColl.Item(lLoop) & "-$$$$-" & sPageId
195:       For lLoop2 = lStart To m_pMasterColl.count
196:         If sValue < m_pMasterColl.Item(lLoop2) Then
197:           m_pMasterColl.Add sValue, sValue, lLoop2
198:           lStart = lLoop2
199:           Exit For
200:         End If
201:         If lLoop2 = m_pMasterColl.count Then
202:           m_pMasterColl.Add sValue, sValue
203:           lStart = lLoop2
204:         End If
205:       Next lLoop2
206:     Next lLoop
207:   End If

  Exit Sub
ErrHand:
211:   MsgBox "AddPageToMasterCollection - " & Erl & " - " & Err.Description
End Sub

Private Sub Form_Load()
On Error GoTo ErrHand:
  Dim pDoc As IMxDocument, pMap As IMap, lLoop As Long
  Dim pFeatLayer As IFeatureLayer
  Dim pMapBook As IDSMapBook
  Dim pSeriesProps As IDSMapSeriesProps
220:   Set pMapBook = GetMapBookExtension(m_pApp)
  If pMapBook Is Nothing Then Exit Sub
  
223:   Set pSeriesProps = pMapBook.ContentItem(0)

225:   optIndex(0).value = True
226:   txtPageNumber.Text = "0"
  
  'Populate the layer list box
229:   cmbLayer.Clear
230:   Set pDoc = m_pApp.Document
231:   Set pMap = FindDataFrame2(m_pApp) 'get the main Map Book data frame
232:   For lLoop = 0 To pMap.LayerCount - 1
233:     If TypeOf pMap.Layer(lLoop) Is IFeatureLayer Then
234:       Set pFeatLayer = pMap.Layer(lLoop)
235:       If Not (pFeatLayer.FeatureClass Is Nothing) Then 'Make sure that the layer in not "disconnected".
236:         If pFeatLayer.FeatureClass.FeatureType <> esriFTAnnotation And _
         pFeatLayer.FeatureClass.FeatureType <> esriFTDimension And _
         pFeatLayer.FeatureClass.FeatureType <> esriFTCoverageAnnotation Then
239:           If UCase(pFeatLayer.Name) <> UCase(pSeriesProps.IndexLayerName) Then
240:             cmbLayer.AddItem pFeatLayer.Name
241:           End If
242:         End If
243:       End If
244:     End If
245:   Next lLoop
246:   If cmbLayer.ListCount > 0 Then
247:     cmbLayer.ListIndex = 0
248:   End If
  
'  'Make sure the wizard stays on top
'249:   TopMost Me
  
  Exit Sub
ErrHand:
255:   MsgBox "frmCreateIndex_Load - " & Erl & " - " & Err.Description
End Sub

Private Sub optIndex_Click(Index As Integer)
259:   If Index = 0 Then
260:     txtPageNumber.Enabled = False
261:   Else
262:     txtPageNumber.Enabled = True
263:   End If
264:   CheckSettings
End Sub

Private Sub txtPageNumber_KeyUp(KeyCode As Integer, Shift As Integer)
268:   If txtPageNumber.Text = "" Then
269:     cmdOK.Enabled = False
270:   Else
271:     If Not IsNumeric(txtPageNumber.Text) Then
272:       txtPageNumber.Text = "0"
273:     End If
274:     CheckSettings
275:   End If
End Sub

Private Sub CheckSettings()
279:   If optIndex(0).value = True Then
280:     If txtOutput.Text <> "" Then
281:       cmdOK.Enabled = True
282:     Else
283:       cmdOK.Enabled = False
284:     End If
285:   Else
286:     If txtOutput.Text <> "" And txtPageNumber.Text <> "" Then
287:       cmdOK.Enabled = True
288:     Else
289:       cmdOK.Enabled = False
290:     End If
291:   End If
End Sub
