VERSION 5.00
Begin VB.Form frmGridSettings 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Grid Generator Wizard"
   ClientHeight    =   10080
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   14745
   Icon            =   "frmGridSettings.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   10080
   ScaleWidth      =   14745
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.Frame fraDestinationFeatureClass 
      Height          =   4695
      Left            =   0
      TabIndex        =   37
      Top             =   0
      Width           =   4815
      Begin VB.CommandButton cmdSetNewGridLayer 
         Height          =   315
         Left            =   4320
         Picture         =   "frmGridSettings.frx":014A
         Style           =   1  'Graphical
         TabIndex        =   75
         ToolTipText     =   "Set new Grid Layer"
         Top             =   1320
         Width           =   315
      End
      Begin VB.TextBox txtNewGridLayer 
         BackColor       =   &H80000011&
         Height          =   315
         Left            =   2040
         Locked          =   -1  'True
         TabIndex        =   74
         Top             =   1320
         Width           =   2295
      End
      Begin VB.OptionButton optLayerSource 
         Caption         =   "Create a new Layer:"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   73
         Top             =   1320
         Width           =   1815
      End
      Begin VB.OptionButton optLayerSource 
         Caption         =   "Use existing Layer:"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   72
         Top             =   960
         Value           =   -1  'True
         Width           =   1695
      End
      Begin VB.ListBox lstRequiredDataLayers 
         Height          =   1410
         Left            =   600
         Style           =   1  'Checkbox
         TabIndex        =   45
         Top             =   3120
         Width           =   3855
      End
      Begin VB.ComboBox cmbPolygonLayers 
         Height          =   315
         Left            =   2040
         Sorted          =   -1  'True
         TabIndex        =   39
         Top             =   920
         Width           =   2535
      End
      Begin VB.CheckBox chkRemovePreviousGrids 
         Caption         =   "Clear existing grids.  This will delete all the current"
         Height          =   255
         Left            =   240
         TabIndex        =   38
         Top             =   1920
         Width           =   4335
      End
      Begin VB.CheckBox chkRemoveEmpties 
         Caption         =   "Don't create empty grids.  A grid is considered empty"
         Height          =   255
         Left            =   240
         TabIndex        =   40
         Top             =   2400
         Width           =   4095
      End
      Begin VB.Label Label12 
         Caption         =   "unless it contains features from at least one of the following selected layers:"
         Height          =   495
         Left            =   600
         TabIndex        =   44
         Top             =   2620
         Width           =   3735
      End
      Begin VB.Label Label11 
         Caption         =   "features in the feature class."
         Height          =   255
         Left            =   600
         TabIndex        =   43
         Top             =   2145
         Width           =   3855
      End
      Begin VB.Label Label5 
         Caption         =   $"frmGridSettings.frx":05C4
         Height          =   615
         Left            =   120
         TabIndex        =   42
         Top             =   240
         Width           =   4575
      End
   End
   Begin VB.Frame fraGridIDs 
      Height          =   4695
      Left            =   4920
      TabIndex        =   25
      Top             =   5280
      Width           =   4815
      Begin VB.Frame Frame1 
         Caption         =   "Identifier Order"
         Height          =   975
         Left            =   120
         TabIndex        =   65
         Top             =   960
         Width           =   4575
         Begin VB.OptionButton optGridIDOrder 
            Caption         =   "Column - Row"
            Height          =   255
            Index           =   1
            Left            =   2520
            TabIndex        =   67
            Top             =   600
            Width           =   1575
         End
         Begin VB.OptionButton optGridIDOrder 
            Caption         =   "Row - Column"
            Height          =   255
            Index           =   0
            Left            =   2520
            TabIndex        =   66
            Top             =   240
            Value           =   -1  'True
            Width           =   1815
         End
         Begin VB.Label Label4 
            Caption         =   "Set the order in which to construct the Identifier."
            Height          =   375
            Left            =   120
            TabIndex        =   68
            Top             =   360
            Width           =   2295
         End
      End
      Begin VB.Frame Frame6 
         Caption         =   "Row ID Style"
         Height          =   975
         Left            =   120
         TabIndex        =   33
         Top             =   3120
         Width           =   2235
         Begin VB.OptionButton optRowIDType 
            Caption         =   "Alpha (A, B, C, ...)"
            Height          =   255
            Index           =   0
            Left            =   180
            TabIndex        =   35
            Top             =   240
            Value           =   -1  'True
            Width           =   1935
         End
         Begin VB.OptionButton optRowIDType 
            Caption         =   "Numeric (0, 1, 2, ...)"
            Height          =   255
            Index           =   1
            Left            =   180
            TabIndex        =   34
            Top             =   600
            Width           =   1860
         End
      End
      Begin VB.Frame Frame7 
         Caption         =   "Column ID Style"
         Height          =   975
         Left            =   2460
         TabIndex        =   30
         Top             =   3120
         Width           =   2235
         Begin VB.OptionButton optColIDType 
            Caption         =   "Alpha (A, B, C, ...)"
            Height          =   255
            Index           =   0
            Left            =   180
            TabIndex        =   32
            Top             =   240
            Width           =   1815
         End
         Begin VB.OptionButton optColIDType 
            Caption         =   "Numeric (0, 1, 2, ...)"
            Height          =   255
            Index           =   1
            Left            =   180
            TabIndex        =   31
            Top             =   600
            Value           =   -1  'True
            Width           =   1935
         End
      End
      Begin VB.Frame Frame8 
         Caption         =   "Starting ID Position"
         Height          =   975
         Left            =   120
         TabIndex        =   27
         Top             =   2040
         Width           =   4575
         Begin VB.OptionButton optStartingIDPosition 
            Caption         =   "Top Left"
            Height          =   255
            Index           =   0
            Left            =   2520
            TabIndex        =   29
            Top             =   240
            Value           =   -1  'True
            Width           =   975
         End
         Begin VB.OptionButton optStartingIDPosition 
            Caption         =   "Lower Left"
            Height          =   255
            Index           =   1
            Left            =   2520
            TabIndex        =   28
            Top             =   600
            Width           =   1160
         End
         Begin VB.Label Label26 
            Caption         =   "Set the position of the (1,1) or (A,A) grid."
            Height          =   495
            Left            =   120
            TabIndex        =   64
            Top             =   360
            Width           =   2295
         End
      End
      Begin VB.CheckBox chkBreak 
         Caption         =   "Use an Underscore as a Row/Column separator"
         Height          =   375
         Left            =   240
         TabIndex        =   26
         Top             =   4200
         Width           =   4335
      End
      Begin VB.Label Label25 
         Caption         =   "Set the format for the Identifier.  The ID will be stored in the Text field specified earlier."
         Height          =   495
         Left            =   120
         TabIndex        =   63
         Top             =   240
         Width           =   3375
      End
      Begin VB.Label lblExampleID 
         Alignment       =   2  'Center
         BackStyle       =   0  'Transparent
         Caption         =   "B3"
         BeginProperty Font 
            Name            =   "Arial Narrow"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00FFFFFF&
         Height          =   255
         Left            =   4320
         TabIndex        =   36
         Top             =   170
         Width           =   375
      End
      Begin VB.Image Image1 
         Height          =   775
         Left            =   3660
         Picture         =   "frmGridSettings.frx":065F
         Stretch         =   -1  'True
         Top             =   160
         Width           =   1020
      End
   End
   Begin VB.Frame fraScaleStart 
      Height          =   4695
      Left            =   9840
      TabIndex        =   1
      Top             =   0
      Width           =   4815
      Begin VB.CommandButton cmdLayersExtent 
         Caption         =   "All Layers"
         Height          =   315
         Left            =   3120
         TabIndex        =   71
         ToolTipText     =   "Extent of all Layers in Map"
         Top             =   3960
         Width           =   1215
      End
      Begin VB.OptionButton optScaleSource 
         Caption         =   "Manual Map Scale"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   10
         Top             =   960
         Value           =   -1  'True
         Width           =   1695
      End
      Begin VB.OptionButton optScaleSource 
         Caption         =   "Current Map Scale"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   9
         Top             =   600
         Width           =   1695
      End
      Begin VB.TextBox txtManualMapScale 
         Height          =   285
         Left            =   2760
         TabIndex        =   8
         Text            =   "0"
         Top             =   940
         Width           =   1455
      End
      Begin VB.TextBox txtStartCoordX 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   600
         TabIndex        =   7
         Text            =   "0"
         Top             =   2520
         Width           =   1695
      End
      Begin VB.TextBox txtStartCoordY 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   2520
         TabIndex        =   6
         Text            =   "0"
         Top             =   2520
         Width           =   1695
      End
      Begin VB.TextBox txtEndCoordX 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   600
         TabIndex        =   5
         Text            =   "0"
         Top             =   3480
         Width           =   1695
      End
      Begin VB.TextBox txtEndCoordY 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   2520
         TabIndex        =   4
         Text            =   "0"
         Top             =   3480
         Width           =   1695
      End
      Begin VB.CommandButton cmdDatasetExtentLL 
         Caption         =   "FClass Extent"
         Height          =   315
         Left            =   480
         TabIndex        =   3
         ToolTipText     =   "Extent of the Grid featureclass"
         Top             =   3960
         Width           =   1215
      End
      Begin VB.CommandButton cmdMapExtentLL 
         Caption         =   "Current Extent"
         Height          =   315
         Left            =   1800
         TabIndex        =   2
         ToolTipText     =   "Current Map Extent"
         Top             =   3960
         Width           =   1215
      End
      Begin VB.Label Label20 
         Caption         =   "Set the Extent within which to create grids."
         Height          =   255
         Left            =   120
         TabIndex        =   58
         Top             =   1800
         Width           =   4575
      End
      Begin VB.Label Label8 
         Caption         =   "Set the Scale / Size for each of the grids."
         Height          =   255
         Left            =   120
         TabIndex        =   57
         Top             =   240
         Width           =   4575
      End
      Begin VB.Label lblCurrentMapScale 
         Caption         =   "5,000"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   2760
         TabIndex        =   14
         Top             =   600
         Width           =   1095
      End
      Begin VB.Label Label1 
         Caption         =   "1 :"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   2400
         TabIndex        =   13
         Top             =   960
         Width           =   375
      End
      Begin VB.Label Label9 
         Caption         =   "Starting Coordinate (LowerLeft):"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   240
         TabIndex        =   12
         Top             =   2160
         Width           =   3375
      End
      Begin VB.Label Label10 
         Caption         =   "Ending Coordinate (UpperRight):"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   240
         TabIndex        =   11
         Top             =   3120
         Width           =   3375
      End
      Begin VB.Label Label7 
         Caption         =   "1 :"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   2400
         TabIndex        =   15
         Top             =   600
         Width           =   375
      End
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "< Back"
      Height          =   375
      Left            =   1440
      TabIndex        =   70
      Top             =   4800
      Width           =   1095
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "Next >"
      Height          =   375
      Left            =   2540
      TabIndex        =   69
      Top             =   4800
      Width           =   1095
   End
   Begin VB.Frame fraDataFrameSize 
      Height          =   4695
      Left            =   0
      TabIndex        =   16
      Top             =   5280
      Width           =   4815
      Begin VB.OptionButton optGridSize 
         Caption         =   "Use the size of the current Data Frame in the Layout"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   21
         Top             =   1200
         Value           =   -1  'True
         Width           =   4335
      End
      Begin VB.OptionButton optGridSize 
         Caption         =   "Specify the Data Frame size (in Layout Units)"
         Height          =   255
         Index           =   1
         Left            =   120
         TabIndex        =   20
         Top             =   2160
         Width           =   4335
      End
      Begin VB.TextBox txtManualGridWidth 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1440
         TabIndex        =   19
         Text            =   "0"
         Top             =   3240
         Width           =   1215
      End
      Begin VB.TextBox txtManualGridHeight 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1440
         TabIndex        =   18
         Text            =   "0"
         Top             =   3720
         Width           =   1215
      End
      Begin VB.ComboBox cmbGridSizeUnits 
         Height          =   315
         ItemData        =   "frmGridSettings.frx":5E21
         Left            =   3480
         List            =   "frmGridSettings.frx":5E2B
         TabIndex        =   17
         Top             =   3240
         Width           =   1095
      End
      Begin VB.Label Label24 
         Alignment       =   1  'Right Justify
         Caption         =   "Units:"
         Height          =   255
         Left            =   2880
         TabIndex        =   62
         Top             =   3240
         Width           =   495
      End
      Begin VB.Label Label23 
         Caption         =   "Note: If you use this option, for best results you should also update the Data Frame size in the Layout to match."
         Height          =   495
         Left            =   480
         TabIndex        =   61
         Top             =   2520
         Width           =   4095
      End
      Begin VB.Label Label22 
         Alignment       =   1  'Right Justify
         Caption         =   "Frame Name:"
         Height          =   255
         Left            =   480
         TabIndex        =   60
         Top             =   1560
         Width           =   975
      End
      Begin VB.Label Label21 
         Caption         =   $"frmGridSettings.frx":5E3A
         Height          =   975
         Left            =   120
         TabIndex        =   59
         Top             =   240
         Width           =   4455
      End
      Begin VB.Label Label2 
         Alignment       =   1  'Right Justify
         Caption         =   "Width : "
         Height          =   255
         Left            =   480
         TabIndex        =   24
         Top             =   3240
         Width           =   855
      End
      Begin VB.Label Label3 
         Alignment       =   1  'Right Justify
         Caption         =   "Height : "
         Height          =   255
         Left            =   360
         TabIndex        =   23
         Top             =   3720
         Width           =   975
      End
      Begin VB.Label lblCurrFrameName 
         Caption         =   "Current Frame"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   1560
         TabIndex        =   22
         Top             =   1560
         Width           =   2895
      End
   End
   Begin VB.Frame fraAttributes 
      Height          =   4695
      Left            =   4920
      TabIndex        =   41
      Top             =   0
      Width           =   4815
      Begin VB.ComboBox cmbFieldColNum 
         Height          =   315
         Left            =   2040
         Sorted          =   -1  'True
         TabIndex        =   53
         Top             =   3960
         Width           =   2535
      End
      Begin VB.ComboBox cmbFieldRowNum 
         Height          =   315
         Left            =   2040
         Sorted          =   -1  'True
         TabIndex        =   52
         Top             =   3360
         Width           =   2535
      End
      Begin VB.ComboBox cmbFieldMapScale 
         Height          =   315
         Left            =   2040
         Sorted          =   -1  'True
         TabIndex        =   51
         Top             =   2760
         Width           =   2535
      End
      Begin VB.ComboBox cmbFieldID 
         Height          =   315
         Left            =   2040
         Sorted          =   -1  'True
         TabIndex        =   48
         Top             =   1200
         Width           =   2535
      End
      Begin VB.Label Label19 
         Alignment       =   1  'Right Justify
         Caption         =   "Column Number:"
         Height          =   255
         Left            =   360
         TabIndex        =   56
         Top             =   3960
         Width           =   1335
      End
      Begin VB.Label Label18 
         Alignment       =   1  'Right Justify
         Caption         =   "Row Number:"
         Height          =   255
         Left            =   360
         TabIndex        =   55
         Top             =   3360
         Width           =   1335
      End
      Begin VB.Label Label17 
         Alignment       =   1  'Right Justify
         Caption         =   "Map Scale:"
         Height          =   255
         Left            =   360
         TabIndex        =   54
         Top             =   2760
         Width           =   1335
      End
      Begin VB.Label Label16 
         Caption         =   $"frmGridSettings.frx":5ED8
         Height          =   735
         Left            =   120
         TabIndex        =   50
         Top             =   1920
         Width           =   4575
      End
      Begin VB.Label Label15 
         Alignment       =   1  'Right Justify
         Caption         =   "ID:"
         Height          =   255
         Left            =   960
         TabIndex        =   49
         Top             =   1200
         Width           =   735
      End
      Begin VB.Label Label14 
         Caption         =   "REQUIRED: Each grid polygon feature requires an Identifier.  Select the Text field that will hold this ID."
         Height          =   495
         Left            =   120
         TabIndex        =   47
         Top             =   720
         Width           =   4575
      End
      Begin VB.Label Label13 
         Caption         =   "Assign roles to field names."
         Height          =   255
         Left            =   120
         TabIndex        =   46
         Top             =   240
         Width           =   4575
      End
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3720
      TabIndex        =   0
      Top             =   4800
      Width           =   1095
   End
End
Attribute VB_Name = "frmGridSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-----------------------------------------------------------------------------
'    USACE JAMB (Just Another Map Book) Extension for ArcGIS
'    Copyright (C) 2010  U.S. Army Corps of Engineers - New Orleans District
'
'    This library is free software; you can redistribute it and/or
'    modify it under the terms of the GNU Lesser General Public
'    License as published by the Free Software Foundation; either
'    version 2.1 of the License, or (at your option) any later version.
'
'    This library is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'    Lesser General Public License for more details.
'
'    You should have received a copy of the GNU Lesser General Public
'    License along with this library; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'-----------------------------------------------------------------------------
''

' Copyright 2006 ESRI
'
' All rights reserved under the copyright laws of the United States
' and applicable international laws, treaties, and conventions.
'
' You may freely redistribute and use this sample code, with or
' without modification, provided you include the original copyright
' notice and use restrictions.
'
' See use restrictions at /arcgis/developerkit/userestrictions.

Option Explicit

Public m_Application As IApplication
Public GridSettings As clsCreateGrids

Public Enum intersectFileType
  ShapeFile = 0
  AccessFeatureClass = 1
  SDEFeatureClass = 2
End Enum

Private m_bIsGeoDatabase As Boolean
Private m_FileType As intersectFileType
Private m_OutputLayer As String
Private m_OutputDataset As String
Private m_OutputFClass As String
Private m_Step As Integer

Private Sub SetControlsState()
    Dim dScale As Double
    Dim dGHeight As Double
    Dim dGWidth As Double
    Dim dStartX As Double
    Dim dStartY As Double
    Dim dEndX As Double
    Dim dEndY As Double
    Dim bValidScale As Boolean
    Dim bValidSize As Boolean
    Dim bValidTarget As Boolean
    Dim bValidIDField As Boolean
    Dim bNewFClassSet As Boolean
    Dim bValidReqdLayers As Boolean
    Dim bValidStart As Boolean
    Dim bValidEnd As Boolean
    Dim bCreatingNewFClass As Boolean
    Dim bDuplicateFieldsSelected As Boolean
    Dim pFL As IFeatureLayer
    Dim pDatasetExtent As IEnvelope
    Dim i As Integer
    
    On Error GoTo eh
    
    ' Protect against zero length string_to_double conversions
56:     If Len(lblCurrentMapScale.Caption) = 0 Then lblCurrentMapScale.Caption = "0"
57:     If Len(txtManualMapScale.Text) = 0 Then
58:         dScale = 0
59:     Else
60:         dScale = CDbl(txtManualMapScale.Text)
61:     End If
62:     If Len(txtManualGridHeight.Text) = 0 Then
63:         dGHeight = 0
64:     Else
65:         dGHeight = CDbl(txtManualGridHeight.Text)
66:     End If
67:     If Len(txtManualGridWidth.Text) = 0 Then
68:         dGWidth = 0
69:     Else
70:         dGWidth = CDbl(txtManualGridWidth.Text)
71:     End If
72:     If Len(txtStartCoordX.Text) = 0 Then
73:         dStartX = 0
74:     Else
75:         dStartX = CDbl(txtStartCoordX.Text)
76:     End If
77:     If Len(txtStartCoordY.Text) = 0 Then
78:         dStartY = 0
79:     Else
80:         dStartY = CDbl(txtStartCoordY.Text)
81:     End If
82:     If Len(txtEndCoordX.Text) = 0 Then
83:         dEndX = 0
84:     Else
85:         dEndX = CDbl(txtEndCoordX.Text)
86:     End If
87:     If Len(txtEndCoordY.Text) = 0 Then
88:         dEndY = 0
89:     Else
90:         dEndY = CDbl(txtEndCoordY.Text)
91:     End If
92: i = 1

    ' Calc values
95:     bValidScale = (optScaleSource(0).value And CDbl(lblCurrentMapScale.Caption) > 0) Or _
                  (optScaleSource(1).value And dScale > 0)
97:     bValidSize = (optGridSize(0).value) Or _
                 (optGridSize(1).value And dGHeight > 0 And dGWidth > 0)
99:     bCreatingNewFClass = optLayerSource(1).value
100:     bNewFClassSet = (Len(txtNewGridLayer.Text) > 0)
101:     bValidTarget = ((cmbPolygonLayers.ListIndex > 0) And (optLayerSource(0).value = True)) Or (bCreatingNewFClass And bNewFClassSet)
102:     bValidIDField = (cmbFieldID.ListIndex >= 0)
103:     bValidReqdLayers = (chkRemoveEmpties.value = vbUnchecked) Or _
                       (chkRemoveEmpties.value = vbChecked And lstRequiredDataLayers.SelCount > 0)
105: i = 2
106:     If bValidTarget And (Not bCreatingNewFClass) Then
107:         Set pFL = FindFeatureLayerByName(cmbPolygonLayers.List(cmbPolygonLayers.ListIndex), m_Application)
108:         If pFL.FeatureClass.FeatureDataset Is Nothing Then
109:             bValidStart = True
110:             bValidEnd = True
111:         Else
112:             Set pDatasetExtent = GetValidExtentForLayer(pFL)
113:             bValidStart = ((dStartX >= pDatasetExtent.XMin) And (dStartX <= pDatasetExtent.XMax)) _
                            And _
                          ((dStartY >= pDatasetExtent.YMin) And (dStartY <= pDatasetExtent.YMax))
116:             bValidEnd = ((dEndX >= pDatasetExtent.XMin) And (dEndX <= pDatasetExtent.XMax)) _
                            And _
                        ((dEndY >= pDatasetExtent.YMin) And (dEndY <= pDatasetExtent.YMax)) _
                            And _
                        ((dEndX > dStartX) And (dEndY > dStartY))
121:         End If
122:     ElseIf bValidTarget And bCreatingNewFClass Then
123:         bValidStart = True
124:         bValidEnd = True
125:     End If
126:     bDuplicateFieldsSelected = (cmbFieldRowNum.ListIndex > 0 And cmbFieldRowNum.ListIndex = cmbFieldColNum.ListIndex) _
                            Or (cmbFieldRowNum.ListIndex > 0 And cmbFieldRowNum.ListIndex = cmbFieldMapScale.ListIndex) _
                            Or (cmbFieldColNum.ListIndex > 0 And cmbFieldColNum.ListIndex = cmbFieldMapScale.ListIndex)
129: i = 3
    
    ' Set states
    Select Case m_Step
        Case 0:     ' Set the target feature layer
134:             cmdBack.Enabled = False
135:             cmdNext.Enabled = bValidTarget And bValidReqdLayers
136:             cmdNext.Caption = "Next >"
137:             cmbPolygonLayers.Enabled = Not bCreatingNewFClass
138:             cmdSetNewGridLayer.Enabled = bCreatingNewFClass
        Case 1:     ' Set the fields to populate
140:             cmdBack.Enabled = True
141:             cmdNext.Enabled = (bValidIDField And Not bDuplicateFieldsSelected)
142:             cmbFieldID.Enabled = Not bCreatingNewFClass
143:             cmbFieldRowNum.Enabled = Not bCreatingNewFClass
144:             cmbFieldColNum.Enabled = Not bCreatingNewFClass
145:             cmbFieldMapScale.Enabled = Not bCreatingNewFClass
        Case 2:     ' Set the scale / starting_coords
147:             cmdBack.Enabled = True
148:             cmdNext.Enabled = bValidScale And bValidStart And bValidEnd
149:             If Not bCreatingNewFClass Then
150:                 cmdDatasetExtentLL.Enabled = Not (pFL.FeatureClass.FeatureDataset Is Nothing)
151:             Else
152:                 cmdDatasetExtentLL.Enabled = False
153:             End If
        Case 3:     ' Set the dataframe properties
155:             cmdBack.Enabled = True
156:             cmdNext.Enabled = bValidSize
157:             cmdNext.Caption = "Next >"
        Case 4:     ' Set the ID values
159:             cmdBack.Enabled = True
160:             cmdNext.Enabled = True
161:             cmdNext.Caption = "Finish"
        Case Else:
163:             cmdBack.Enabled = False
164:             cmdNext.Enabled = False
165:     End Select
166: i = 4
    
168:     txtManualMapScale.Enabled = optScaleSource(1).value
169:     txtManualGridWidth.Enabled = optGridSize(1).value
170:     txtManualGridHeight.Enabled = optGridSize(1).value
171:     cmbGridSizeUnits.Enabled = optGridSize(1).value
    ' Set display
173:     If bValidStart Then
174:         txtStartCoordX.ForeColor = (&H0)    ' Black
175:         txtStartCoordY.ForeColor = (&H0)
176:     Else
177:         txtStartCoordX.ForeColor = (&HFF)   ' Red
178:         txtStartCoordY.ForeColor = (&HFF)
179:     End If
180:     If bValidEnd Then
181:         txtEndCoordX.ForeColor = (&H0)      ' Black
182:         txtEndCoordY.ForeColor = (&H0)
183:     Else
184:         txtEndCoordX.ForeColor = (&HFF)     ' Red
185:         txtEndCoordY.ForeColor = (&HFF)
186:     End If
187:     If optScaleSource(1).value Then
188:         If bValidScale Then
189:             txtManualMapScale.ForeColor = (&H0)      ' Black
190:         Else
191:             txtManualMapScale.ForeColor = (&HFF)     ' Red
192:         End If
193:     End If
194:     If optGridSize(1).value Then
195:         If bValidSize Then
196:             txtManualGridWidth.ForeColor = (&H0)      ' Black
197:             txtManualGridHeight.ForeColor = (&H0)
198:         Else
199:             txtManualGridWidth.ForeColor = (&HFF)     ' Red
200:             txtManualGridHeight.ForeColor = (&HFF)
201:         End If
202:     End If
    
    Exit Sub
205:     Resume
eh:
207:     MsgBox Err.Description, vbExclamation, "SetControlsState " & i
End Sub

Private Sub chkBreak_Click()
211:     lblExampleID.Caption = GenerateExampleID
End Sub

Private Sub chkRemoveEmpties_Click()
215:     SetControlsState
End Sub

Private Sub cmbFieldColNum_Click()
219:     SetControlsState
End Sub

Private Sub cmbFieldID_Click()
223:     SetControlsState
End Sub

Private Sub cmbFieldMapScale_Click()
227:     SetControlsState
End Sub

Private Sub cmbFieldRowNum_Click()
231:     SetControlsState
End Sub

Private Sub cmbPolygonLayers_Click()
    Dim pFL As IFeatureLayer
    Dim pFields As IFields
    Dim lLoop As Long
    ' Populate the fields combo boxes
239:     If cmbPolygonLayers.ListIndex > 0 Then
240:         Set pFL = FindFeatureLayerByName(cmbPolygonLayers.List(cmbPolygonLayers.ListIndex), m_Application)
241:         Set pFields = pFL.FeatureClass.Fields
242:         cmbFieldColNum.Clear
243:         cmbFieldID.Clear
244:         cmbFieldMapScale.Clear
245:         cmbFieldRowNum.Clear
246:         cmbFieldRowNum.AddItem "<None>"
247:         cmbFieldColNum.AddItem "<None>"
248:         cmbFieldMapScale.AddItem "<None>"
249:         For lLoop = 0 To pFields.FieldCount - 1
250:             If pFields.Field(lLoop).Type = esriFieldTypeString Then
251:                 cmbFieldID.AddItem pFields.Field(lLoop).Name
252:             ElseIf pFields.Field(lLoop).Type = esriFieldTypeDouble Or _
                   pFields.Field(lLoop).Type = esriFieldTypeInteger Or _
                   pFields.Field(lLoop).Type = esriFieldTypeSmallInteger Or _
                   pFields.Field(lLoop).Type = esriFieldTypeSingle Then
256:                 cmbFieldColNum.AddItem pFields.Field(lLoop).Name
257:                 cmbFieldRowNum.AddItem pFields.Field(lLoop).Name
258:                 cmbFieldMapScale.AddItem pFields.Field(lLoop).Name
259:             End If
260:         Next
        'Select the first field name in the combo boxes
262:         cmbFieldRowNum.ListIndex = 0
263:         cmbFieldColNum.ListIndex = 0
264:         cmbFieldMapScale.ListIndex = 0
        'Search for default field names and automatically select them.
266:         If cmbFieldRowNum.ListCount > 0 Then
267:             For lLoop = 0 To cmbFieldRowNum.ListCount - 1
268:                 If cmbFieldRowNum.List(lLoop) = c_DefaultFld_RowNum Then
269:                     cmbFieldRowNum.ListIndex = lLoop
270:                     Exit For
271:                 End If
272:             Next
273:             For lLoop = 0 To cmbFieldColNum.ListCount - 1
274:                 If cmbFieldColNum.List(lLoop) = c_DefaultFld_ColNum Then
275:                     cmbFieldColNum.ListIndex = lLoop
276:                     Exit For
277:                 End If
278:             Next
279:             For lLoop = 0 To cmbFieldMapScale.ListCount - 1
280:                 If cmbFieldMapScale.List(lLoop) = c_DefaultFld_Scale Then
281:                     cmbFieldMapScale.ListIndex = lLoop
282:                     Exit For
283:                 End If
284:             Next
285:         End If
286:         If cmbFieldID.ListCount > 0 Then
287:             For lLoop = 0 To cmbFieldID.ListCount - 1
288:                 If cmbFieldID.List(lLoop) = c_DefaultFld_GridID Then
289:                     cmbFieldID.ListIndex = lLoop
290:                     Exit For
291:                 End If
292:             Next
293:         End If
294:     End If
295:     SetControlsState
End Sub

Private Sub cmdBack_Click()
299:     m_Step = m_Step - 1
300:     If m_Step < 0 Then
301:         m_Step = 0
302:     End If
303:     SetVisibleControls m_Step
304:     SetControlsState
End Sub

Private Sub cmdClose_Click()
308:     Unload Me
End Sub

Private Sub CollateGridSettings()
    Dim pMx As IMxDocument
    Dim pCreateGrid As New clsCreateGrids
    Dim pFrameElement As IElement
    Dim sDestLayerName As String
    Dim lLoop As Long
    ' Populate class
318:     If (optGridIDOrder(0).value) Then
319:         pCreateGrid.IdentifierOrder = Row_Column
320:     Else
321:         pCreateGrid.IdentifierOrder = Column_Row
322:     End If
323:     If (optRowIDType(0).value) Then
324:         pCreateGrid.RowIDType = Alphabetical
325:     Else
326:         pCreateGrid.RowIDType = Numerical
327:     End If
328:     If (optColIDType(0).value) Then
329:         pCreateGrid.ColIDType = Alphabetical
330:     Else
331:         pCreateGrid.ColIDType = Numerical
332:     End If
333:     If (optStartingIDPosition(0).value) Then
334:         pCreateGrid.IDStartPositionType = TopLeft
335:     Else
336:         pCreateGrid.IDStartPositionType = LowerLeft
337:     End If
338:     If (optScaleSource(0).value) Then
339:         pCreateGrid.MapScale = CDbl(lblCurrentMapScale.Caption)
340:     Else
341:         pCreateGrid.MapScale = CDbl(txtManualMapScale.Text)
342:     End If
343:     If (optGridSize(0).value) Then
344:         Set pFrameElement = GetDataFrameElement(GetActiveDataFrameName(m_Application), m_Application)
345:         pCreateGrid.FrameWidthInPageUnits = pFrameElement.Geometry.Envelope.Width
346:         pCreateGrid.FrameHeightInPageUnits = pFrameElement.Geometry.Envelope.Height
347:     Else
348:         pCreateGrid.FrameWidthInPageUnits = CDbl(txtManualGridWidth.Text)
349:         pCreateGrid.FrameHeightInPageUnits = CDbl(txtManualGridHeight.Text)
350:     End If
351:     sDestLayerName = cmbPolygonLayers.List(cmbPolygonLayers.ListIndex)
352:     If optLayerSource(0).value Then
353:         Set pCreateGrid.DestinationFeatureLayer = FindFeatureLayerByName(sDestLayerName, m_Application)
354:     End If
355:     pCreateGrid.StartingCoordinateLL_X = CDbl(txtStartCoordX.Text)
356:     pCreateGrid.StartingCoordinateLL_Y = CDbl(txtStartCoordY.Text)
357:     pCreateGrid.EndingCoordinateUR_X = CDbl(txtEndCoordX.Text)
358:     pCreateGrid.EndingCoordinateUR_Y = CDbl(txtEndCoordY.Text)
359:     pCreateGrid.UseUnderscore = (chkBreak.value = vbChecked)
360:     pCreateGrid.FieldNameGridID = cmbFieldID.List(cmbFieldID.ListIndex)
361:     If cmbFieldRowNum.ListIndex > 0 Then pCreateGrid.FieldNameRowNum = cmbFieldRowNum.List(cmbFieldRowNum.ListIndex)
362:     If cmbFieldColNum.ListIndex > 0 Then pCreateGrid.FieldNameColNum = cmbFieldColNum.List(cmbFieldColNum.ListIndex)
363:     If cmbFieldMapScale.ListIndex > 0 Then pCreateGrid.FieldNameScale = cmbFieldMapScale.List(cmbFieldMapScale.ListIndex)
364:     pCreateGrid.NoEmptyGrids = (chkRemoveEmpties.value = vbChecked)
365:     If pCreateGrid.NoEmptyGrids Then
366:         pCreateGrid.ClearRequiredDataLayers
367:         For lLoop = 0 To lstRequiredDataLayers.ListCount - 1
368:             If lstRequiredDataLayers.Selected(lLoop) Then
369:                 pCreateGrid.AddRequiredDataLayer lstRequiredDataLayers.List(lLoop)
370:             End If
371:         Next
372:     End If
373:     pCreateGrid.RemoveCurrentGrids = (chkRemovePreviousGrids.value = vbChecked)
    ' Place grid settings on Public form property (so calling function can use them)
375:     Set Me.GridSettings = pCreateGrid
End Sub

Private Sub cmdDatasetExtentLL_Click()
    Dim pFL As IFeatureLayer
    Dim pDatasetExtent As IEnvelope
    
382:     If cmbPolygonLayers.ListIndex > 0 Then
383:         Set pFL = FindFeatureLayerByName(cmbPolygonLayers.List(cmbPolygonLayers.ListIndex), m_Application)
384:         Set pDatasetExtent = GetValidExtentForLayer(pFL)
385:         txtStartCoordX.Text = Format(pDatasetExtent.XMin, "#,###,##0.00")
386:         txtStartCoordY.Text = Format(pDatasetExtent.YMin, "#,###,##0.00")
387:         txtEndCoordX.Text = Format(pDatasetExtent.XMax - 100, "#,###,##0.00")
388:         txtEndCoordY.Text = Format(pDatasetExtent.YMax - 100, "#,###,##0.00")
389:         SetControlsState
390:     End If
End Sub

Private Sub cmdLayersExtent_Click()
    Dim pMx As IMxDocument
    Dim pEnv As IEnvelope
    Dim pElement As IElement
    Dim pMapFrame As IMapFrame
    Dim pActiveView As IActiveView
    
    On Error GoTo eh
    
402:     Set pMx = m_Application.Document
403:     Set pActiveView = pMx.ActiveView
404:     If TypeOf pActiveView Is IPageLayout Then
405:         Set pElement = GetDataFrameElement(pMx.FocusMap.Name, m_Application)
406:         Set pMapFrame = pElement
407:         Set pEnv = pMapFrame.MapBounds
408:         Set pActiveView = pMapFrame.Map
409:         Set pEnv = pActiveView.FullExtent
410:     Else
411:         Set pEnv = pActiveView.FullExtent
412:     End If
    
414:     txtStartCoordX.Text = Format(pEnv.XMin, "#,###,##0.00")
415:     txtStartCoordY.Text = Format(pEnv.YMin, "#,###,##0.00")
416:     txtEndCoordX.Text = Format(pEnv.XMax, "#,###,##0.00")
417:     txtEndCoordY.Text = Format(pEnv.YMax, "#,###,##0.00")
    
419:     SetControlsState
    
    Exit Sub
eh:
423:     MsgBox Err.Description, , "cmdLayersExtent_Click"
End Sub

Private Sub cmdMapExtentLL_Click()
    Dim pMx As IMxDocument
    Dim pEnv As IEnvelope
    Dim pElement As IElement
    Dim pMapFrame As IMapFrame
    Dim pActiveView As IActiveView
    
    On Error GoTo eh
    
435:     Set pMx = m_Application.Document
436:     Set pActiveView = pMx.ActiveView
437:     If TypeOf pActiveView Is IPageLayout Then
438:         Set pElement = GetDataFrameElement(pMx.FocusMap.Name, m_Application)
439:         Set pMapFrame = pElement
440:         Set pEnv = pMapFrame.MapBounds
441:     Else
442:         Set pEnv = pActiveView.Extent
443:     End If
    
445:     txtStartCoordX.Text = Format(pEnv.XMin, "#,###,##0.00")
446:     txtStartCoordY.Text = Format(pEnv.YMin, "#,###,##0.00")
447:     txtEndCoordX.Text = Format(pEnv.XMax, "#,###,##0.00")
448:     txtEndCoordY.Text = Format(pEnv.YMax, "#,###,##0.00")
    
450:     SetControlsState
    
    Exit Sub
eh:
454:     MsgBox Err.Description, , "cmdMapExtentLL"
End Sub

Private Sub cmdNext_Click()
    Dim pMx As IMxDocument
    Dim pFeatureLayer As IFeatureLayer
    Dim pOutputFClass As IFeatureClass
    Dim pNewFields As IFields
    
    On Error GoTo eh
    ' Step
465:     m_Step = m_Step + 1
    ' If we're creating a new fclass, we can skip a step
467:     If m_Step = 1 And (optLayerSource(1).value) Then
468:         m_Step = m_Step + 1
469:     End If
    ' If FINISH
471:     If m_Step >= 5 Then
472:         CollateGridSettings
        ' If creating a new layer
474:         If optLayerSource(1).value Then
            ' Create the feature class
476:             Set pMx = m_Application.Document
477:             Set pNewFields = CreateTheFields
            Select Case m_FileType
                Case ShapeFile
480:                     Set pOutputFClass = NewShapeFile(m_OutputLayer, pMx.FocusMap, pNewFields)
                Case AccessFeatureClass
482:                     Set pOutputFClass = NewAccessFile(m_OutputLayer, _
                            m_OutputDataset, m_OutputFClass, pNewFields)
484:             End Select
485:             If pOutputFClass Is Nothing Then
486:                 Err.Raise vbObjectError, "cmdNext", "Could not create the new output feature class."
487:             End If
            ' Create new layer
489:             Set pFeatureLayer = New FeatureLayer
490:             Set pFeatureLayer.FeatureClass = pOutputFClass
491:             pFeatureLayer.Name = pFeatureLayer.FeatureClass.AliasName
            ' Add the new layer to arcmap & reset the GridSettings object to point at it
493:             pMx.FocusMap.AddLayer pFeatureLayer
494:             Set GridSettings.DestinationFeatureLayer = pFeatureLayer
495:         End If
        'Prepare to Generate the Grids
497:         PrepareGenerateGrids m_Application
498:     Else
499:         SetVisibleControls m_Step
500:         SetControlsState
501:     End If
    
    Exit Sub
eh:
505:     MsgBox "cmdNext_Click - " & Erl & " - " & Err.Description
506:     m_Step = m_Step - 1
End Sub

'Call this subroutine to generate the grids and unload the form
Private Sub PrepareGenerateGrids(pApp As IApplication)
On Error GoTo eh
    Dim pCreateGrid As clsCreateGrids
513:     Set pCreateGrid = Me.GridSettings
514:     If pCreateGrid Is Nothing Then
        Exit Sub
516:     End If
517:     pCreateGrid.GenerateGrids2 pApp
    ' Clean up
519:     Set pCreateGrid = Nothing
520:     Unload Me
    Exit Sub
eh:
523:     MsgBox "Error: " & Erl & " - " & Err.Description, , "PrepareGenerateGrids"
End Sub

Private Sub cmdSetNewGridLayer_Click()
On Error GoTo ErrHand:
  Dim pGxFilter As IGxObjectFilter
  Dim pGXBrow As IGxDialog, bFlag As Boolean
  Dim pSel As IEnumGxObject, pApp As IApplication
  
533:   Set pGxFilter = New GxFilter
534:   Set pApp = m_Application
535:   Set pGXBrow = New GxDialog
536:   Set pGXBrow.ObjectFilter = pGxFilter
537:   pGXBrow.Title = "Output feature class or shapefile"
538:   bFlag = pGXBrow.DoModalSave(pApp.hwnd)
  
540:   If bFlag Then
    Dim pObj As IGxObject
542:     Set pObj = pGXBrow.FinalLocation
543:     m_bIsGeoDatabase = True
544:     If UCase(pObj.Category) = "FOLDER" Then
545:       If InStr(1, pGXBrow.Name, ".shp") > 0 Then
546:         txtNewGridLayer.Text = pObj.FullName & "\" & pGXBrow.Name
547:       Else
548:         txtNewGridLayer.Text = pObj.FullName & "\" & pGXBrow.Name & ".shp"
549:       End If
550:       m_OutputLayer = txtNewGridLayer.Text
551:       m_bIsGeoDatabase = False
552:       m_FileType = ShapeFile
553:      CheckOutputFile
554:     Else
      Dim pLen As Long
556:       pLen = Len(pObj.FullName) - Len(pObj.BaseName) - 1
557:       txtNewGridLayer.Text = Left(pObj.FullName, pLen)
558:       m_OutputLayer = Left(pObj.FullName, pLen)
559:       m_OutputDataset = pObj.BaseName
560:       m_OutputFClass = pGXBrow.Name
561:       m_bIsGeoDatabase = True
562:       If UCase(pObj.Category) = "PERSONAL GEODATABASE FEATURE DATASET" Then
563:         m_FileType = AccessFeatureClass
564:       Else
565:         m_FileType = SDEFeatureClass
566:       End If
567:     End If
568:   Else
569:     txtNewGridLayer.Text = ""
570:     m_bIsGeoDatabase = False
571:   End If
572:   SetControlsState
  
  Exit Sub
ErrHand:
576:   MsgBox "cmdSetNewGridLayer_Click - " & Erl & " - " & Err.Description
End Sub

Private Sub Form_Load()
    Dim pMx As IMxDocument
    Dim bRenewCoordsX As Boolean
    Dim bRenewCoordsY As Boolean
    
    On Error GoTo eh
    
586:     Set pMx = m_Application.Document
587:     Me.Height = 5665
588:     Me.Width = 4935
589:     m_Step = 0
590:     LoadLayersComboBox
591:     LoadUnitsComboBox
592:     lblExampleID.Caption = GenerateExampleID
593:     lblCurrFrameName.Caption = GetActiveDataFrameName(m_Application)
594:     If pMx.FocusMap.MapUnits = esriUnknownUnits Then
595:         MsgBox "Error: The map has unknown units and therefore cannot calculate a Scale." _
            & vbCrLf & "Cannot create Map Grids at this time.", vbCritical, "Create Map Grids"
597:         Unload Me
        Exit Sub
599:     End If
600:     lblCurrentMapScale.Caption = Format(pMx.FocusMap.MapScale, "#,###,##0")
601:     Call cmdMapExtentLL_Click
602:     SetVisibleControls m_Step
    
604:     SetControlsState
    
'    'Make sure the wizard stays on top
'564:     TopMost Me
    
    Exit Sub
eh:
611:     MsgBox "frmGridSettings: Error loading the form: " & Erl & " - " & Err.Description & vbCrLf _
        & vbCrLf & "Attempting to continue the load...", , "frmGridSettings: Form_Load "
    On Error Resume Next
614:     SetVisibleControls m_Step
615:     SetControlsState
End Sub

Private Sub LoadUnitsComboBox()
    Dim pMx As IMxDocument
    Dim sPageUnitsDesc As String
    Dim pPage As IPage
    
    On Error GoTo eh
    
    ' Init
626:     Set pMx = m_Application.Document
627:     Set pPage = pMx.PageLayout.Page
628:     sPageUnitsDesc = GetUnitsDescription(pPage.Units)
629:     cmbGridSizeUnits.Clear
    ' Add
631:     cmbGridSizeUnits.AddItem sPageUnitsDesc
    'cmbGridSizeUnits.AddItem "Map Units (" & sMapUnitsDesc & ")"
    ' Set page units as default
634:     cmbGridSizeUnits.ListIndex = 0
    
    Exit Sub
eh:
638:     Err.Raise vbObjectError, "LoadUnitsComboBox", "Error in LoadUnitsComboBox" & vbCrLf & Erl & " - " & Err.Description
End Sub

Private Sub LoadLayersComboBox()
On Error GoTo ErrHand:
    Dim pMx As IMxDocument
    Dim lLoop As Long
    Dim pFL As IFeatureLayer
    Dim pFC As IFeatureClass
    Dim sPreviousLayer  As String
    Dim lResetIndex As Long
    
    'Init
651:     Set pMx = m_Application.Document
'    If cmbPolygonLayers.ListCount > 0 Then
'        sPreviousLayer = cmbPolygonLayers.List(cmbPolygonLayers.ListIndex)
'    End If
655:     cmbPolygonLayers.Clear
656:     lstRequiredDataLayers.Clear
657:     cmbPolygonLayers.AddItem "<Not Set>"
    ' For all layers
659:     For lLoop = 0 To pMx.FocusMap.LayerCount - 1
        ' If a feature class
661:         If TypeOf pMx.FocusMap.Layer(lLoop) Is IFeatureLayer Then
662:             Set pFL = pMx.FocusMap.Layer(lLoop)
663:             Set pFC = pFL.FeatureClass

665:             If Not (pFC Is Nothing) Then 'If the feature class is not disconnected.
              ' If a polygon layer
667:               If pFC.ShapeType = esriGeometryPolygon Then
                  ' Add to combo box
669:                   cmbPolygonLayers.AddItem pFL.Name
  '                If pFL.Name = sPreviousLayer Then
  '                    lResetIndex = (cmbPolygonLayers.ListCount - 1)
  '                End If
673:               End If
674:               lstRequiredDataLayers.AddItem pFL.Name
675:             End If

677:         End If
678:     Next
    'cmbPolygonLayers.ListIndex = lResetIndex
    Exit Sub
ErrHand:
682:   MsgBox "LoadLayersComboBox - " & Erl & " - " & Err.Description
End Sub

Private Sub SetCurrentMapScaleCaption()
    Dim pMx As IMxDocument
    On Error GoTo eh
688:     Set pMx = m_Application.Document
689:     lblCurrentMapScale.Caption = Format(pMx.FocusMap.MapScale, "#,###,##0")
    Exit Sub
eh:
692:     lblCurrentMapScale.Caption = "<Scale Unknown>"
End Sub


Private Sub Form_Unload(Cancel As Integer)
697:     Set m_Application = Nothing
698:     Set GridSettings = Nothing
End Sub


Private Sub lstRequiredDataLayers_Click()
703:     SetControlsState
End Sub

Private Sub optColIDType_Click(Index As Integer)
707:     lblExampleID.Caption = GenerateExampleID
708:     SetControlsState
End Sub

Private Sub optGridIDOrder_Click(Index As Integer)
712:     lblExampleID.Caption = GenerateExampleID
713:     SetControlsState
End Sub

Private Sub optGridSize_Click(Index As Integer)
    Dim pMx As IMxDocument
718:     Set pMx = m_Application.Document
719:     lblCurrFrameName.Caption = pMx.FocusMap.Name
720:     SetControlsState
End Sub

Private Sub optLayerSource_Click(Index As Integer)
    ' If creating a new fclass to hold the grids
725:     If Index = 1 Then
        ' Set the field names (will be created automatically)
727:         cmbFieldID.Clear
728:         cmbFieldRowNum.Clear
729:         cmbFieldColNum.Clear
730:         cmbFieldMapScale.Clear
731:         cmbFieldID.AddItem "<None>"
732:         cmbFieldRowNum.AddItem "<None>"
733:         cmbFieldColNum.AddItem "<None>"
734:         cmbFieldMapScale.AddItem "<None>"
735:         cmbFieldID.AddItem c_DefaultFld_GridID
736:         cmbFieldRowNum.AddItem c_DefaultFld_RowNum
737:         cmbFieldColNum.AddItem c_DefaultFld_ColNum
738:         cmbFieldMapScale.AddItem c_DefaultFld_Scale
739:         cmbFieldID.ListIndex = 1
740:         cmbFieldRowNum.ListIndex = 1
741:         cmbFieldColNum.ListIndex = 1
742:         cmbFieldMapScale.ListIndex = 1
743:     End If
744:     SetControlsState
End Sub

Private Sub optRowIDType_Click(Index As Integer)
748:     lblExampleID.Caption = GenerateExampleID
749:     SetControlsState
End Sub

Private Function GenerateExampleID() As String
    Dim sRow As String, sCol As String
754:     If optStartingIDPosition(0).value Then  'Top left
755:         If (optRowIDType(0).value) Then
756:             sRow = "A"
757:         Else
758:             sRow = "1"
759:         End If
760:         If (optColIDType(0).value) Then
761:             sCol = "C"
762:         Else
763:             sCol = "3"
764:         End If
765:     Else                                    ' Lower left
766:         If (optRowIDType(0).value) Then
767:             sRow = "C"
768:         Else
769:             sRow = "3"
770:         End If
771:         If (optColIDType(0).value) Then
772:             sCol = "C"
773:         Else
774:             sCol = "3"
775:         End If
776:     End If
777:     If (optGridIDOrder(0).value) Then
778:         If chkBreak.value = vbChecked Then
779:             GenerateExampleID = sRow & "_" & sCol
780:         Else
781:             GenerateExampleID = sRow & sCol
782:         End If
783:     Else
784:         If chkBreak.value = vbChecked Then
785:             GenerateExampleID = sCol & "_" & sRow
786:         Else
787:             GenerateExampleID = sCol & sRow
788:         End If
789:     End If
End Function

Private Sub optScaleSource_Click(Index As Integer)
793:     If Index = 0 Then
794:         SetCurrentMapScaleCaption
795:     End If
796:     SetControlsState
End Sub

Private Sub optStartingIDPosition_Click(Index As Integer)
800:     lblExampleID.Caption = GenerateExampleID
801:     SetControlsState
End Sub

Private Sub txtEndCoordX_Change()
805:     SetControlsState
End Sub

Private Sub txtEndCoordX_KeyPress(KeyAscii As Integer)
    ' If a non-numeric (that is not a decimal point)
810:     If (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) _
     And KeyAscii <> Asc(".") _
     And Chr(KeyAscii) <> vbBack Then
        ' Do not allow this button to work
814:         KeyAscii = 0
    ' If a decimal point, make sure we only ever get one of them
816:     ElseIf KeyAscii = Asc(".") Then
817:         If InStr(txtEndCoordX.Text, ".") > 0 Then
818:             KeyAscii = 0
819:         End If
820:     End If
End Sub

Private Sub txtEndCoordY_Change()
824:     SetControlsState
End Sub

Private Sub txtEndCoordY_KeyPress(KeyAscii As Integer)
    ' If a non-numeric (that is not a decimal point)
829:     If (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) _
     And KeyAscii <> Asc(".") _
     And Chr(KeyAscii) <> vbBack Then
        ' Do not allow this button to work
833:         KeyAscii = 0
    ' If a decimal point, make sure we only ever get one of them
835:     ElseIf KeyAscii = Asc(".") Then
836:         If InStr(txtEndCoordY.Text, ".") > 0 Then
837:             KeyAscii = 0
838:         End If
839:     End If
End Sub

Private Sub txtManualGridHeight_Change()
843:     SetControlsState
End Sub

Private Sub txtManualGridHeight_KeyPress(KeyAscii As Integer)
    ' If a non-numeric (that is not a decimal point)
848:     If (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) _
     And KeyAscii <> Asc(".") _
     And Chr(KeyAscii) <> vbBack Then
        ' Do not allow this button to work
852:         KeyAscii = 0
    ' If a decimal point, make sure we only ever get one of them
854:     ElseIf KeyAscii = Asc(".") Then
855:         If InStr(txtManualGridHeight.Text, ".") > 0 Then
856:             KeyAscii = 0
857:         End If
858:     End If
End Sub

Private Sub txtManualGridWidth_Change()
862:     SetControlsState
End Sub

Private Sub txtManualGridWidth_KeyPress(KeyAscii As Integer)
    ' If a non-numeric (that is not a decimal point)
867:     If (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) _
     And KeyAscii <> Asc(".") _
     And Chr(KeyAscii) <> vbBack Then
        ' Do not allow this button to work
871:         KeyAscii = 0
    ' If a decimal point, make sure we only ever get one of them
873:     ElseIf KeyAscii = Asc(".") Then
874:         If InStr(txtManualGridWidth.Text, ".") > 0 Then
875:             KeyAscii = 0
876:         End If
877:     End If
End Sub

Private Sub txtManualMapScale_Change()
881:     SetControlsState
End Sub

Private Sub txtManualMapScale_KeyPress(KeyAscii As Integer)
    ' If a non-numeric (that is not a decimal point)
886:     If (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) _
     And KeyAscii <> Asc(".") _
     And Chr(KeyAscii) <> vbBack Then
        ' Do not allow this button to work
890:         KeyAscii = 0
    ' If a decimal point, make sure we only ever get one of them
892:     ElseIf KeyAscii = Asc(".") Then
893:         If InStr(txtManualMapScale.Text, ".") > 0 Then
894:             KeyAscii = 0
895:         End If
896:     End If
End Sub

Public Sub Tickle()
900:     Call Form_Load
End Sub

Private Sub txtStartCoordX_Change()
904:     SetControlsState
End Sub

Private Sub txtStartCoordX_KeyPress(KeyAscii As Integer)
    ' If a non-numeric (that is not a decimal point)
909:     If (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) _
     And KeyAscii <> Asc(".") _
     And Chr(KeyAscii) <> vbBack Then
        ' Do not allow this button to work
913:         KeyAscii = 0
    ' If a decimal point, make sure we only ever get one of them
915:     ElseIf KeyAscii = Asc(".") Then
916:         If InStr(txtStartCoordX.Text, ".") > 0 Then
917:             KeyAscii = 0
918:         End If
919:     End If
End Sub

Private Sub txtStartCoordY_Change()
923:     SetControlsState
End Sub

Private Sub txtStartCoordY_KeyPress(KeyAscii As Integer)
    ' If a non-numeric (that is not a decimal point)
928:     If (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) _
     And KeyAscii <> Asc(".") _
     And Chr(KeyAscii) <> vbBack Then
        ' Do not allow this button to work
932:         KeyAscii = 0
    ' If a decimal point, make sure we only ever get one of them
934:     ElseIf KeyAscii = Asc(".") Then
935:         If InStr(txtStartCoordY.Text, ".") > 0 Then
936:             KeyAscii = 0
937:         End If
938:     End If
End Sub

Private Sub SetVisibleControls(iStep As Integer)
    ' Hide all
943:     fraAttributes.Visible = False
944:     fraDataFrameSize.Visible = False
945:     fraDestinationFeatureClass.Visible = False
946:     fraGridIDs.Visible = False
947:     fraScaleStart.Visible = False
    ' Show applicable frame, set top/left
    Select Case iStep
        Case 0:
951:             fraDestinationFeatureClass.Visible = True
952:             fraDestinationFeatureClass.Top = 0
953:             fraDestinationFeatureClass.Left = 0
        Case 1:
955:             fraAttributes.Visible = True
956:             fraAttributes.Top = 0
957:             fraAttributes.Left = 0
        Case 2:
959:             fraScaleStart.Visible = True
960:             fraScaleStart.Top = 0
961:             fraScaleStart.Left = 0
        Case 3:
963:             fraDataFrameSize.Visible = True
964:             fraDataFrameSize.Top = 0
965:             fraDataFrameSize.Left = 0
        Case 4:
967:             fraGridIDs.Visible = True
968:             fraGridIDs.Top = 0
969:             fraGridIDs.Left = 0
        Case Else:
971:             MsgBox "Invalid Step Value."
972:     End Select
End Sub

Private Sub CheckOutputFile()
    'Check the output option
977:     If txtNewGridLayer.Text <> "" Then
978:         If DoesShapeFileExist(txtNewGridLayer.Text) Then
979:             MsgBox "Shape file name already being used!!!"
980:             txtNewGridLayer.Text = ""
981:         End If
982:     End If
End Sub

Private Function CreateTheFields() As IFields
    Dim newField As IField
    Dim newFieldEdit As IFieldEdit
    Dim pNewFields As IFields
    Dim pFieldsEdit As IFieldsEdit
    Dim pGeomDef As IGeometryDef
    Dim pGeomDefEdit As IGeometryDefEdit
    Dim pMx As IMxDocument
    
    ' Init
995:     Set pNewFields = New Fields
996:     Set pFieldsEdit = pNewFields
997:     Set pMx = m_Application.Document
    ' Field: OID
999:     Set newField = New Field
1000:     Set newFieldEdit = newField
1001:     With newFieldEdit
1002:         .Name = "OID"
1003:         .Type = esriFieldTypeOID
1004:         .AliasName = "Object ID"
1005:         .IsNullable = False
1006:     End With
1007:     pFieldsEdit.AddField newField
    'Set pFieldsEdit.Field(0) = pFieldEdit
    
'    ' Field: SHAPE
'    Set newField = New Field
'    Set newFieldEdit = newField
'    newFieldEdit.Name = c_DefaultFld_Shape
'    newFieldEdit.Type = esriFieldTypeGeometry
'    Set pGeomDef = New GeometryDef
'    Set pGeomDefEdit = pGeomDef
'    With pGeomDefEdit
'        .GeometryType = esriGeometryPolygon
'        Set .SpatialReference = pMx.FocusMap.SpatialReference ' New UnknownCoordinateSystem
'    End With
'    Set newFieldEdit.GeometryDef = pGeomDef
'    pFieldsEdit.AddField newField
    ' Field: GRID IDENTIFIER
1024:     Set newField = New Field
1025:     Set newFieldEdit = newField
1026:     With newFieldEdit
1027:       .Name = c_DefaultFld_GridID
1028:       .AliasName = "GridIdentifier"
1029:       .Type = esriFieldTypeString
1030:       .IsNullable = True
1031:       .length = 50
1032:     End With
1033:     pFieldsEdit.AddField newField
    ' Field: ROW NUMBER
1035:     Set newField = New Field
1036:     Set newFieldEdit = newField
1037:     With newFieldEdit
1038:       .Name = c_DefaultFld_RowNum
1039:       .AliasName = "Row Number"
1040:       .Type = esriFieldTypeInteger
1041:       .IsNullable = True
1042:     End With
1043:     pFieldsEdit.AddField newField
    ' Field: COLUMN NUMBER
1045:     Set newField = New Field
1046:     Set newFieldEdit = newField
1047:     With newFieldEdit
1048:       .Name = c_DefaultFld_ColNum
1049:       .AliasName = "Column Number"
1050:       .Type = esriFieldTypeInteger
1051:       .IsNullable = True
1052:     End With
1053:     pFieldsEdit.AddField newField
    ' Field: SCALE
1055:     Set newField = New Field
1056:     Set newFieldEdit = newField
1057:     With newFieldEdit
1058:       .Name = c_DefaultFld_Scale
1059:       .AliasName = "Plot Scale"
1060:       .Type = esriFieldTypeDouble
1061:       .IsNullable = True
1062:       .Precision = 18
1063:       .Scale = 11
1064:     End With
1065:     pFieldsEdit.AddField newField
    ' Return
1067:     Set CreateTheFields = pFieldsEdit
End Function

